namespace Math {


	// Computes the natural logarithm of the given value. The value must be greater than zero.
	float naturalLogarithmOf(float);
	double naturalLogarithmOf(double);

	// Computes the base 2 logarithm of the given value. The value must be greater than zero.
	float base2LogarithmOf(float);
	double base2LogarithmOf(double);

	// Computes the given base raised to the given power.
	float raisedToPower(float, float exponent);
	double raisedToPower(double, double exponent);

	// Computes e raised to the given power.
	float eRaisedToPower(float);
	double eRaisedToPower(double);

	// Computes the base raised to the given power. Optimized for integer powers.
	// (complexity: logarithmic in magnitude of exponent)
	float raisedToPower(float, SIntLeast2B exponent);
	double raisedToPower(double, SIntLeast2B exponent);


} // Math