// Data structures in Namcos Ace Combat 3.



namespace Namco {


	// Ace Combat 3, released in 1997 for PlayStation.
	namespace AceCombat3 {


		struct BPH_Header {
			UInt4B_LE id; // AC3E
			UInt4B_LE unknown[3];
			UInt4B_LE numberOfPointers;
			CDPointer pointers[]; // always sorted
		};


		// Ace Combat 3 uses a checksum to detect pirated discs. This seems to be a magic key according to a comment on a cheat
		//  collection (http://www.codetwink.com/view-cheats-2040-title-ace+combat+3-electrosphere.html):
		//
		//    Well, Namco, we must say that you caught us a bit off guard with this 'Protected' game. If you were targeting out
		//    Cheat Device codes being on, then you failed. Because with Cheat Device pro it doesnt turn codes on right away with
		//    out the C1000000 0000 code. I think that you should have waited a second or 2 longer before doing that checksum if you
		//    were in fact targeting out Cheat Device. Also Namco.. does this value mean anything to you?? A6E2BA6C... I would think
		//    it does :) If you were in fact targeting out 'Copied Discs' and not Cheat Device.. and it works for that purpose...
		//    then hats off for not blocking out Cheat Device and not blocking out modchipped systems. Obviously the game doesnt
		//    have anti-mod protection as it has been tested on 5 different modded machines here and boots fine. I think this is the
		//    better approach to take.. Its too bad that we'll still post codes like this to by pass your checksum tho.. Sorry, but
		//    if we didnt do it... noone would... For those who have no idea what I'm talking about goto the following
		//    http://www.htc.net/~brianj/ace3.gif And you'll see this 'Protection' that they put into the game..
		//    However if you want to see it for yourself.. Enter the following code and you'll be able to see the screen live and up
		//    close...
		//       C1000000 0000
		//       D0164308 0023
		//       8016430A 1000
		//
		// The linked image reads:
		//
		//                                             ! WARNING !
		//
		//                                 An error has occurred while loading.
		//     This software product WILL NOT operate under either one/or both of the following conditions:
		//                            If the game CD is an illegally copied product.
		//          If your PlayStation(R) console has been modified with any unauthorized components.
		//   If the game disc is a legitimate product, and your PlayStation(R) console has never undergone any
		//    unauthorized modification, please contact your local PlayStation(R) Customer Service department.
		//               Details can be found at the back of your PlayStation(R) software manual.
		//
		// The number is not found anywhere else on the web.
		auto constexpr magicKey = 0xA6E2BA6C;


	} // AceCombat3


} // Namco