// Increments the given number atomically and returns the new value.
UInt4B atomicIncrement(UInt4B volatile &);
#if COMPILED_FOR_X86_64
	UInt8B atomicIncrement(UInt8B volatile &);
#endif
// Decrements the given number atomically and returns the new value.
UInt4B atomicDecrement(UInt4B volatile &);
#if COMPILED_FOR_X86_64
	UInt8B atomicDecrement(UInt8B volatile &);
#endif
// Replaces the given number atomically and returns the previous value.
UInt4B atomicExchange(UInt4B volatile &, UInt4B);


// A very simple spin lock. Initialize with SPIN_LOCK_INITIALIZER.
// No RAII because its typically global and Visual C++ is very bad at optimizing static constructors (even initializing a
//  global to zero  a no-op  emits an entire dedicated function).
struct alignas(4) SpinLock {
	UInt4B volatile lock; // nonzero if locked; safe due to Win32 memory requirements
};

#define SPIN_LOCK_INITIALIZER { 0 } // initialize to unlocked

void lock(SpinLock &);

void unlock(SpinLock &);