// Interoperability with the PlayStation, Sonys 1995 video game console.



// Sony is a Japanese electronics developer.
namespace Sony {


	// PlayStation, the 1995 console.
	namespace PSX {


		// The location and layout of a texture in the frame buffer.
		struct DrawAttribute_Texture {
			UInt2B_LE data; // according to Nocash PSX Specifications  GPU  GPU Rendering Attributes  Texpage Attribute

			// X coordinate of the texture page, in frame buffer pixels (i.e. 2-B words).
			//   always aligned to 64 pixels
			UIntLeast2B xInFrameBufferPixels() const;

			// Y coordinate of the texture page, in pixels.
			//   always aligned to 256 pixels
			UIntLeast2B yInPixels() const;

			// The textures bit depth.
			//   4: 16 indexed colors
			//   8: 256 indexed colors
			//   16: High Color with transparency
			UIntLeast1B bitsPerPixel() const;

		};


		// The location of a color palette in the frame buffer.
		//   used by all textured draw commands
		struct DrawAttribute_Palette {
			UInt2B_LE data; // according to Nocash PSX Specifications  GPU  GPU Rendering Attributes  Clut Attribute

			// X coordinate, in frame buffer pixels (i.e. 2-B words).
			//   always aligned to 16 pixels (in accordance with PSX GPU requirements)
			UIntLeast2B xInFrameBufferPixels() const;

			// Y coordinate, in pixels.
			UIntLeast2B yInPixels() const;

		};


	} // PSX


} // Sony