; All Visual C++ 2015 C-Runtime replacements which can only be implemented in Assembly (x86-32 versions).
;   functions for stack manipulation, e.g. _alloca()
;   security checks which run in function prologues



_PAGESIZE_ equ 1000h

.686
.model flat
.code

; __chkstk() probes the stack in 4096 B intervals. Visual C++ inserts it on _alloca() or if a function uses more than 4096 B
;  of stack space. It guarantees sufficient stack commit size for random access to local variables.
;
; The function is called from the prologs of other functions, and therefore does not follow any x86 calling convention. This
;  makes an assembler implementation necessary:
;    the only parameter (size to probe) is passed in eax
;    there may be no room to store local variables, so only eax, and ecx can be used
__chkstk proc
		; copied from code compiled by Visual C++ 2015:
		push     ecx
		lea      ecx, [esp + 4]
		sub      ecx, eax
		sbb      eax, eax
		not      eax
		and      ecx, eax
		mov      eax, esp
		and      eax, not(_PAGESIZE_ - 1)
	cs10:
		cmp      ecx, eax
		bnd jb   cs20
		mov      eax, ecx
		pop      ecx
		xchg     eax, esp
		mov      eax, dword ptr [eax]
		mov      dword ptr [esp], eax
		bnd ret
	cs20:
		sub      eax, _PAGESIZE_
		test     dword ptr [eax], eax
		jmp      cs10
__chkstk endp

_alloca_probe = __chkstk

end