namespace Formats {


	namespace DID {


		namespace SPR {


			namespace Error { enum : UInt4B {

				// Unexpected end of file in header.
				// (more)   nothing
				// (return) ignored
				eofInHeader = 0x80000F00,

				// Either zero or too many frames in header.
				// (more)   nothing
				// (return) ignored
				badNumberOfFrames,

				// A frame offset is off file limits.
				// (more)   nothing
				// (return) ignored
				badFrameOffset,

				// A frame is either too small (zero pixels wide or high) or its width is not a multiple of four.
				// (more)   nothing
				// (return) ignored
				badFrameDimension,

				// Unexpected end of file in frame.
				// (more)   nothing
				// (return) ignored
				eofInFrame

			}; }


		} // SPR


	} // DID


} // Formats