namespace Formats {


	namespace id {


		namespace SPR {


			namespace Warning { enum : UInt4B {

				// warning: bad header (unknown orientation)
				// (more)   nothing
				// (return) yes to proceed anyway; no to abort
				badOrientation = 0x40000700,

				// warning: bad header (unknown blending mode)
				// (more)   nothing
				// (return) yes to proceed anyway; no to abort
				badMode,

				// warning: bad header (dimensions zero or too large)
				// (more)   nothing
				// (return) yes to proceed anyway; no to abort
				badDimensions,

				// warning: bad header (unknown synchronization)
				// (more)   nothing
				// (return) yes to proceed anyway; no to abort
				badSynchronization,

				// warning: bad frame (unexpected end of file); skipping all later frames
				// (more)   nothing
				// (return) yes to skip all later frames; no to abort
				eofInFrame,

				// warning: bad frame (dimensions zero or too large); skipping all later frames
				// (more)   nothing
				// (return) yes to skip all later frames; no to abort
				badFrameDimensions,

				// warning: bad frame (unexpected end of file in pixels); skipping all later frames
				// (more)   nothing
				// (return) yes to skip all later frames; no to abort
				eofInPixels

			}; } // Warning


			namespace Error { enum : UInt4B {

				// error: bad header (unexpected end of file)
				// (more)   nothing
				// (return) ignored
				eofInHeader = 0x80000700,

				// error: bad header (signature not IDSP)
				// (more)   nothing
				// (return) ignored
				badSignature,

				// error: bad header (version not 2)
				// (more)   nothing
				// (return) ignored
				badVersion,

				// error: bad header (no frames)
				// (more)   nothing
				// (return) ignored
				empty,

				// error: bad header (more than 65535 frames)
				// (more)   nothing
				// (return) ignored
				tooManyFrames,

				// error: bad header (palette does not hat 256 colors)
				// (more)   nothing
				// (return) ignored
				badPalette,

				// error: bad palette (unexpected end of file)
				// (more)   nothing
				// (return) ignored
				eofInPalette

			}; } // Error


		} // SPR


	} // id


} // Formats