namespace Formats {


	namespace id {


		namespace WAD {


			namespace Warning { enum : UInt4B {

				// warning: bad 3D GameStudio A4 mip texture (too small); skipping
				// (more)   nothing
				// (return) ignored
				v2_54_tooSmall = 0x40000A00,

				// warning: bad 3D GameStudio A4 mip texture (too large); skipping
				// (more)   nothing
				// (return) ignored
				v2_54_tooLarge,

				// warning: bad 3D GameStudio A4 mip texture (sidelength not a multiple of 8); skipping
				// (more)   nothing
				// (return) ignored
				v2_54_sidelength,

				// warning: bad 3D GameStudio A4 mip texture (unexpected end of file); skipping
				// (more)   nothing
				// (return) ignored
				v2_54_eof,

				// warning: bad Half-Life mip texture (too small); skipping
				// (more)   nothing
				// (return) ignored
				v3_40_tooSmall,

				// warning: bad Half-Life mip texture (too large); skipping
				// (more)   nothing
				// (return) ignored
				v3_40_tooLarge,

				// warning: bad Half-Life mip texture (sidelength not a multiple of 8); skipping
				// (more)   nothing
				// (return) ignored
				v3_40_sidelength,

				// warning: bad Half-Life mip texture (unexpected end of file); skipping
				// (more)   nothing
				// (return) ignored
				v3_40_eof,

				// warning: empty Half-Life texture; skipping
				// (more)   nothing
				// (return) ignored
				v3_42_empty,

				// warning: bad Half-Life texture (too large); skipping
				// (more)   nothing
				// (return) ignored
				v3_42_tooLarge,

				// warning: bad Half-Life texture (unexpected end of file); skipping
				// (more)   nothing
				// (return) ignored
				v3_42_eof,

				// warning: empty Half-Life font; skipping
				// (more)   nothing
				// (return) ignored
				v3_46_empty,

				// warning: bad Half-Life font (too large); skipping
				// (more)   nothing
				// (return) ignored
				v3_46_tooLarge,

				// warning: bad Half-Life font (unexpected end of file); skipping
				// (more)   nothing
				// (return) ignored
				v3_46_eof,

				// warning: bad item (unexpected end of file); skipping
				// (more)   nothing
				// (return) ignored
				eofInItem,

				// warning: compression not yet supported
				// (more)   nothing
				// (return) yes to skip the compressed item; no to abort
				compressionNotSupported,

				// warning: unknown Quake item
				// (more)   nothing
				// (return) yes to skip the unknown item; no to abort
				v2_unknownItem,

				// warning: unknown Half-Life item
				// (more)   nothing
				// (return) yes to skip the unknown item; no to abort
				v3_unknownItem

			}; } // Warning


			namespace Error { enum : UInt4B {

				// error: bad header (unexpected end of file)
				// (more)   nothing
				// (return) ignored
				eofInHeader = 0x80000A00,

				// error: bad header (signature not WAD2 or WAD3)
				// (more)   nothing
				// (return) ignored
				badSignature,

				// error: empty
				// (more)   nothing
				// (return) ignored
				empty,

				// error: bad directory (unexpected end of file)
				// (more)   nothing
				// (return) ignored
				eofInDirectory

			}; } // Error


		} // WAD


	} // namespace id


} // Formats