namespace OS {


	namespace Win32 {


		namespace D3D11 {


			namespace Info { enum : UInt4B {

				// Reports the available feature level.
				//  (more)   equals the D3D_FEATURE_LEVEL enumeration:
				//           0x9100: D3D9
				//           0x9200: D3D9.0a
				//           0x9300: D3D9.0b
				//           0xA000: D3D10.0
				//           0xA100: D3D10.1
				//           0xB000: D3D11.0
				//           0xB100: D3D11.1
				//           0xB200: D3D11.2
				//           0xB300: D3D11.3
				//           0xB400: D3D11.4
				//           0xC000: D3D12.0
				//           0xC100: D3D12.1
				//  (return) ignored
				featureLevel = 0x10000D00

			}; } // Info


			namespace Error { enum : UInt4B {

				// The debug layer is not installed on this machine.
				//  (more)   D3D11 error code
				//  (return) ignored
				noDebugLayer = 0x80000D00,

				// The API has been called with invalid parameters, in an invalid state, or the functionality is not available. This is most
				//  likely a programming error.
				//  (more)   D3D11 error code
				//  (return) ignored
				misuse,

				// There are too many state objects.
				//  (more)   D3D11 error code
				//  (return) ignored
				outOfStates,

				// There are too many instances of a particular type of view.
				//  (more)   D3D11 error code
				//  (return) ignored
				outOfViews,

				// The GPU is too old.
				//  (more)   nothing
				//  (return) ignored
				gpuTooOld,

				// The driver is being updated. Probably the system needs rebooting.
				//  (more)   nothing
				//  (return) ignored
				driverUpdatePending,

				// D3D11 is not installed on the system. You may be running WindowsVista or 7 without platform upgrade.
				//  (more)   nothing
				//  (return) ignored
				noD3D11,

				// Lost GPU access. Possible reasons include driver errors, system overload, or misuse.
				//  (more)   nothing
				//  (return) ignored
				lostGPU

			}; } // Error


		} // D3D11


	} // Win32


} // OS