namespace OS {


	namespace Win32 {


		namespace Error { enum : UInt4B {

			// A Win32 call failed.
			//  (more)   Win32 error code
			//  (return) ignored
			unspecified = 0x80000B00,

			// A registry key access failed.
			//  (more)   OS::Win32::Registry::KeyError describing the error
			//  (return) ignored
			registryKeyError,

			// A registry value access failed.
			//  (more)   OS::Win32::Registry::ValueError describing the error
			//  (return) ignored
			registryValueError

		}; } // Error


		namespace Registry {
			uses struct Key;

			struct KeyError {
				USize             hive;
				UTF16Unit const * keyPath;
				UIntLeast4B       code;
			};

			struct ValueError {
				Key const *       key;
				UTF16Unit const * valueName;
				UIntLeast4B       code;
			};

		} // Registry


	} // Win32


} // OS