namespace Sony {


	namespace PSX {


		namespace TIM {


			namespace Info { enum : UInt4B {

				// info: extra data after end of file
				//  (more)   nothing
				//  (return) ignored
				extraData = 0x10000900

			}; } // Info


			namespace Warning { enum : UInt4B {

				// warning: palettes outside of PSX framebuffer
				//  (more)   nothing
				//  (return) yes to proceed anyway; no to abort
				palettesOff = 0x40000900,

				// warning: palettes not 16-pixel aligned
				//  (more)   nothing
				//  (return) yes to proceed anyway; no to abort
				palettesNotAligned,

				// warning: too many colors per palette
				//  (more)   nothing
				//  (return) yes to spread excess colors over additional palettes; no to abort
				tooManyColorsPerPalette,

				// warning: palettes in a true-color image
				//  (more)   nothing
				//  (return) yes to proceed anyway; no to abort
				needlessPalettes,

				// warning: no palettes in an indexed image
				//  (more)   nothing
				//  (return) yes to proceed anyway; no to abort
				noPalettes,

				// warning: pixels outside PSX framebuffer
				//  (more)   nothing
				//  (return) yes to proceed anyway; no to abort
				pixelsOff,

				// warning: no pixels
				//  (more)   nothing
				//  (return) ignored
				noPixels,

				// warning: image dimensions do not match size record
				//  (more)   nothing
				//  (return) yes to proceed anyway; no to abort
				badPixelsSize

			}; } // Warning


			namespace Error { enum : UInt4B {

				// error: damaged header (unknown flags)
				//  (more)   nothing
				//  (return) ignored
				badFlags = 0x80000900,

				// error: mixed files not yet supported
				//  (more)   nothing
				//  (return) ignored
				unsupportedFormat,

				// error: damaged header (unknown pixel format)
				//  (more)   nothing
				//  (return) ignored
				badPixelFormat,

				// error: damaged palettes header (unexpected end of file)
				//  (more)   nothing
				//  (return) ignored
				eofInPalettesHeader,

				// error: bad palettes (too many colors)
				//  (more)   nothing
				//  (return) ignored
				tooManyColorsPerPalette,

				// error: bad palettes (too few colors for that bit depth)
				//  (more)   nothing
				//  (return) ignored
				tooFewColorsPerPalette,

				// error: bad palettes (wrong size)
				//  (more)   nothing
				//  (return) ignored
				badPalettesSize,

				// error: bad palettes (unexpected end of file)
				//  (more)   nothing
				//  (return) ignored
				eofInPalettes,

				// error: damaged pixels header (unexpected end of file)
				//  (more)   nothing
				//  (return) ignored
				eofInPixelsHeader,

				// error: damaged pixels (unexpected end of file)
				//  (more)   nothing
				//  (return) ignored
				eofInPixels,

				// error: height exceeds PSX framebuffer (512 pixels)
				//  (more)   nothing
				//  (return) ignored
				imageTooHigh,

				// error: width exceeds PSX framebuffer (1024 pixels)
				//  (more)   nothing
				//  (return) ignored
				imageTooWide

			}; }


		} // TIM


	} // PSX


} // Sony