#include "framework.hpp"
#include "SIMD.hpp"
#include "Text.hpp"

import_from(User32) SInt4B API_CALL MessageBoxA(
	void *                 hWnd,
	ASCIICharacter const * lpText,
	ASCIICharacter const * lpCaption,
	UInt4B                 uType
);

import_from(Kernel32) void API_CALL OutputDebugStringA(ASCIICharacter const *);

namespace OS {
	namespace Win32 {
		void captureCallStack(UTF16Unit[16 * 48]);
	}
}

#if COMPILED_BY_VISUAL_CPP

	// Visual C++ intrinsics. On Clang and GCC, the __builtin_ counterparts are used, so no declaration is required.
	import {

		__m128 _mm_setzero_ps();
		__m128i _mm_setzero_si128();
		__m128 _mm_set_ss(float);
		__m128 _mm_set_ps(float, float, float, float);
		__m128i _mm_set_epi32(int, int, int, int);
		__m128i _mm_cvtsi32_si128(int);
		__m128d _mm_set_sd(double);
		__m128d _mm_set1_pd(double);
		__m128i _mm_set1_epi8(char);
		__m128i _mm_set1_epi16(short);
		__m128d _mm_set_pd(double, double);
		float _mm_cvtss_f32(__m128);
		int _mm_cvt_ss2si(__m128);
		__m128i _mm_cvtps_epi32(__m128);
		int _mm_cvtsd_si32(__m128d);
		__m128i _mm_cvttps_epi32(__m128);
		int _mm_cvtsi128_si32(__m128i);
		double _mm_cvtsd_f64(__m128d);
		__m128 _mm_cvtpd_ps(__m128d);
		__m128d _mm_cvtps_pd(__m128);
		__m128 _mm_cvtepi32_ps(__m128i);
		__m128d _mm_cvtepi32_pd(__m128i);
		__m128i _mm_packs_epi32(__m128i, __m128i);
		__m128i _mm_packs_epi16(__m128i, __m128i);
		__m128i _mm_packus_epi16(__m128i, __m128i);
		__m128 _mm_castsi128_ps(__m128i);
		__m128d _mm_castsi128_pd(__m128i);
		__m128i _mm_castps_si128(__m128);

		__m128 _mm_loadu_ps(float const *);
		__m128d _mm_loadu_pd(double const *);
		__m128 _mm_loadl_pi(__m128, float const *);
		__m128i _mm_loadl_epi64(SInt4B const *);
		__m128i _mm_loadu_si128(__m128i const *);
		__m128 _mm_load_ss(float const *);
		void _mm_store_ss(float *, __m128);
		void _mm_storel_pi(float *, __m128);
		void _mm_storeh_pi(float *, __m128);
		void _mm_storeu_ps(float *, __m128);
		void _mm_storeu_pd(double *, __m128d);
		void _mm_storeu_si128(__m128i *, __m128i);
		void _mm_store_sd(double *, __m128d);
		void _mm_storel_epi64(SInt4B *, __m128i);

		__m128 _mm_add_ps(__m128, __m128);
		__m128 _mm_sub_ps(__m128, __m128);
		__m128 _mm_mul_ps(__m128, __m128);
		__m128 _mm_div_ps(__m128, __m128);
		__m128 _mm_and_ps(__m128, __m128);
		__m128 _mm_andnot_ps(__m128, __m128);
		__m128 _mm_or_ps(__m128, __m128);
		__m128 _mm_xor_ps(__m128, __m128);
		__m128 _mm_min_ps(__m128, __m128);
		__m128 _mm_max_ps(__m128, __m128);
		__m128d _mm_add_pd(__m128d, __m128d);
		__m128d _mm_mul_pd(__m128d, __m128d);
		__m128d _mm_min_pd(__m128d, __m128d);
		__m128d _mm_max_pd(__m128d, __m128d);
		__m128d _mm_and_pd(__m128d, __m128d);
		__m128d _mm_andnot_pd(__m128d, __m128d);
		__m128i _mm_add_epi8(__m128i, __m128i);
		__m128i _mm_adds_epu8(__m128i, __m128i);
		__m128i _mm_add_epi16(__m128i, __m128i);
		__m128i _mm_add_epi32(__m128i, __m128i);
		__m128i _mm_subs_epu8(__m128i, __m128i);
		__m128i _mm_sub_epi32(__m128i, __m128i);
		__m128i _mm_or_si128(__m128i, __m128i);
		__m128i _mm_xor_si128(__m128i, __m128i);
		__m128i _mm_and_si128(__m128i, __m128i);
		__m128i _mm_andnot_si128(__m128i, __m128i);
		__m128i _mm_sub_epi16(__m128i, __m128i);
		__m128i _mm_madd_epi16(__m128i, __m128i);
		__m128i _mm_srai_epi16(__m128i, int);
		__m128i _mm_srli_epi16(__m128i, int);
		__m128i _mm_slli_epi32(__m128i, int);
		__m128i _mm_srli_epi32(__m128i, int);
		__m128i _mm_slli_epi64(__m128i, int);
		__m128i _mm_srli_si128(__m128i, int);
		__m128i _mm_slli_si128(__m128i, int);
		__m128i _mm_mullo_epi16(__m128i, __m128i);
		__m128i _mm_mulhi_epu16(__m128i, __m128i);

		__m128 _mm_shuffle_ps(__m128, __m128, int);
		__m128 _mm_movelh_ps(__m128, __m128);
		__m128 _mm_movehl_ps(__m128, __m128);
		__m128 _mm_unpacklo_ps(__m128, __m128);
		__m128i _mm_unpacklo_epi8(__m128i, __m128i);
		__m128i _mm_unpackhi_epi8(__m128i, __m128i);
		__m128i _mm_shufflelo_epi16(__m128i, int);
		__m128i _mm_shuffle_epi32(__m128i, int);
		__m128i _mm_unpackhi_epi32(__m128i, __m128i);
		__m128i _mm_srai_epi32(__m128i, int);
		__m128i _mm_unpacklo_epi16(__m128i, __m128i);
		__m128i _mm_unpacklo_epi32(__m128i, __m128i);
		__m128i _mm_unpackhi_epi64(__m128i, __m128i);
		__m128i _mm_unpacklo_epi64(__m128i, __m128i);

		__m128i _mm_cmplt_epi32(__m128i, __m128i);
		__m128i _mm_cmpeq_epi32(__m128i, __m128i);
		__m128i _mm_cmpgt_epi32(__m128i, __m128i);
		__m128 _mm_cmpeq_ps(__m128, __m128);
		__m128 _mm_cmpneq_ps(__m128, __m128);
		__m128 _mm_cmplt_ps(__m128, __m128);
		__m128 _mm_cmple_ps(__m128, __m128);
		__m128 _mm_cmpgt_ps(__m128, __m128);
		__m128i _mm_cmplt_epi8(__m128i, __m128i);
		__m128i _mm_cmpeq_epi8(__m128i, __m128i);

		int _mm_movemask_ps(__m128);
		int _mm_movemask_epi8(__m128i);

		unsigned short _byteswap_ushort(unsigned short);
		unsigned long _byteswap_ulong(unsigned long);
		unsigned __int64 _byteswap_uint64(unsigned __int64);

		unsigned int _rotr(unsigned int, int);
		unsigned char _BitScanForward(unsigned long * _Index, unsigned long _Mask);

#		if COMPILED_FOR_X86_32
			unsigned char _BitScanReverse(unsigned long * _Index, unsigned long _Mask);
#		elif COMPILED_FOR_X86_64
			unsigned char _BitScanReverse64(unsigned long * _Index, unsigned __int64 _Mask);
			__m128i _mm_cvtsi64x_si128(__int64);
			__int64 _mm_cvtss_si64x(__m128);
			__int64 _mm_cvtsd_si64x(__m128d);
#		else
#			error TODO
#		endif

	}

#	define IMPL_SWIZZLED_INT4B_XYZW(V, A, B, C, D) _mm_shuffle_epi32(V, (D << 6) + (C << 4) + (B << 2) + A)

	local __m128i SIMD_CALL xmmAllBitsOne() {
		// There is no NOT in SSE, so the fastest way is comparing a register to itself:
		//   a register with undefined content could be used (without data dependecy because this identity is hardwired to CPUs),
		//    but Visual C++ forces stack access for undefined values
		auto const junk = _mm_setzero_si128();
		return _mm_cmpeq_epi32(junk, junk);
	}

	local __m128i dividedBy255_UInt2Bx8(__m128i const v) {
		// According to StackOverflow, How to divide 16-bit integer by 255 with using SSE?:
		//
		//   GCC optimizes x/255 with x is unsigned short to DWORD(x * 0x8081) >> 0x17 which can further be simplified to
		//    HWORD(x * 0x8081) >> 7
		//
		return _mm_srli_epi16(_mm_mulhi_epu16(v, _mm_set1_epi16(-32639)), 7);
	}

#elif COMPILED_BY_CLANG || COMPILED_BY_GCC

	// Some built-ins require these types for intermediate values:
	typedef int SInt4Bx2 __attribute__((vector_size(8)));
	typedef short SInt2Bx8 __attribute__((vector_size(16)));
	typedef long long SInt8Bx2 __attribute__((vector_size(16)));
#	define IMPL_SWIZZLED_INT4B_XYZW(V, A, B, C, D) __builtin_shufflevector(V, V, A, B, C, D)

#else
#	error TODO
#endif

#if 0 == (COMPILED_FOR_LITTLE_ENDIAN + COMPILED_FOR_BIG_ENDIAN)
#	error TODO
#endif


// Compiler- and architecture-independent vector swizzling function.
//   indices are template arguments because they must be immediates with SSE
template <int lane0, int lane1, int lane2, int lane3> local floatx4 SIMD_CALL shuffled(floatx4 const vector) {
	// PSHUFD is sometimes proposed in place of SHUFPS because its a one-parameter intrinsic. But thats worse:
	//   type casts interfere with compiler optimization
	//   code bloat because PSHUFD is 56 bytes (SHUFPS is 45)
	//   four-cycle bypass delay due to domain change on 2010-era CPUs
	return { 
#	if COMPILED_BY_VISUAL_CPP
		_mm_shuffle_ps(vector.floats, vector.floats, (lane3 << 6) + (lane2 << 4) + (lane1 << 2) + lane0)
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		__builtin_shufflevector(vector.floats, vector.floats, lane0, lane1, lane2, lane3)
#	endif
	};
}

// Compilers and architectures have very different syntax for vector swizzling, and this macro abstracts it.
#define SWIZZLED_INT4BX4(VEC, XINDEX, YINDEX, ZINDEX, WINDEX) IMPL_SWIZZLED_INT4B_XYZW(VEC, XINDEX, YINDEX, ZINDEX, WINDEX)



// Operators for placement new / delete.
// Technically, theyd need to be included via <new>; defining them here breaks standard compliance:
//    The placement overloads of operator new and operator delete that employ an additional void * parameter are [] also known
//     as pointer placement. Their definitions by the Standard C++ library, which it is not permitted for a C++ program to
//     replace or override, []
//  (http://en.wikipedia.org/wiki/Placement_syntax#Default_placement).
// Intentionally break standard compliance here:
//    1) Including <new> causes a huge load of 3rd-party headers being included (i.e. the STL if compiled by Visual C++). No
//       language feature should be hard-wired to the STL.
//    2) Visual C++ inserts a nullptr test after each placement new. A custom implementation can use the __assume() hint to
//       eliminate this.

#if COMPILED_BY_VISUAL_CPP
	// Visual C++ defines its placement new inline (probably for performance without whole program optimization). Including
	//  Visual C++ STL therefore causes a multiply defined symbol error once their definitions collide with those here. To
	//  avoid that, the definitions here are defined inline, too; but they are also declared extern so other translation units
	//  find them.
#	define VISUAL_CPP_WORKAROUND extern inline
#else
#	define VISUAL_CPP_WORKAROUND
#endif

VISUAL_CPP_WORKAROUND void * operator new(USize, void * address) noexcept {
	MUST(nullptr != address); // work around Visual C++ inserting needless nullptr test
	return address;
}

VISUAL_CPP_WORKAROUND void operator delete(void *, void *) noexcept { }

VISUAL_CPP_WORKAROUND void * operator new [](USize, void * address) noexcept {
	MUST(nullptr != address); // work around Visual C++ inserting needless nullptr test
	return address;
}

VISUAL_CPP_WORKAROUND void operator delete [](void *, void *) noexcept { }

#include <stdarg.h>

void OUTLINE_CODE DIAGNOSTIC_OUTPUT(char const * toZeroTerminatedFormat, ...) {
	char buffer[81900];
	va_list parameters;
	va_start(parameters, toZeroTerminatedFormat);
	Text::format(range(buffer), toZeroTerminatedFormat, (Text::VariableParameters const *)parameters);
	va_end(parameters);
	OutputDebugStringA(buffer);
}

#if _DEBUG

#	include "OS Win32 DbgHelp.hpp"

	bool shouldIgnoreAssertion(char const * toMessage) {
		ASCIICharacter textBuffer[32768];

		// Print a message to the debuggers output window first, because this never fails.
		OutputDebugStringA(
			"\n"
			"assertion violated:\n"
			"    "
		);
		OutputDebugStringA(toMessage);
		OutputDebugStringA(
			"\n"
			"in\n"
		);
		OS::Win32::DbgHelp::print(OS::Win32::DbgHelp::currentCallStack(2));
		OutputDebugStringA("\n\n");

		// Show the message box.
		(*Text::format(range(toBeginningOf(textBuffer), toEndOf(textBuffer) - 1),
			"%s\n"
			"\n"
			"Proceed anyway?",
			toMessage
		).toEnd) = 0; // must be zero-terminated for Win32

#		if COMPILED_BY_VISUAL_CPP
			// Message boxes inside callbacks abort the callback in Windows8. This not only hides the messages, it also leaves the
			//  programs data in invalid state. Prevent this by catching access violations.
			__try {
#		endif
			switch(MessageBoxA(
				nullptr,
				textBuffer,
				"assertion violated",
				0x00012014 // MB_YESNO + MB_ICONERROR + MB_SETFOREGROUND + MB_TASKMODAL
			)) {

				case 6: // IDYES
					return yes; // proceed

				case 7: // IDNO
					return no; // break into the debugger

				default:
					// While shutting down and in certain callbacks, Win32 wont allow new windows. This makes the message box fail, and
					//  in this case the best option is to break into the debugger (and NOT abort like MFCs ASSERT() does!).
					return no;
			}
#		if COMPILED_BY_VISUAL_CPP
			} __except(1) { // EXCEPTION_EXECUTE_HANDLER
				return no; // the message box failed pretty bad; break into debugger
			}
#		endif
	}

#endif // _DEBUG
	

// Loads two elements from the given address.
//  no alignment required
//  memory order (lowest address becomes first element)
floatx2 SIMD_CALL loadx2(float const memory[2]) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_loadl_pi(_mm_setzero_ps(), memory) }; // XY00
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXY[0], toXY[1] };
#	endif
}

// Creates a vector of two elements with the given value.
floatx2 SIMD_CALL loadx2(float const a) {
#	if COMPILED_BY_VISUAL_CPP
		//  _mm_set_ps1: should be just shuffling since a already is in a SSE register, but Visual C++ 2015 doesnt get it
		//  _mm_set_ps:  looks wasteful, but generates optimal code
		return { _mm_set_ps(a, a, a, a) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a, a, a, a };
#	endif
}

// Extracts lane [0].
float SIMD_CALL a_of(floatx2 const ab) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(ab.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return ab.floats[0];
#	endif
}

// Extracts lanes [0] and [1].
floatx2 SIMD_CALL ab_of(floatx4 const abcd) {
#	if COMPILED_BY_VISUAL_CPP
		return { abcd.floats };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { abcd.floats[0], abcd.floats[1] };
#	endif
}

// Broadcasts lane [0]s value.
floatx2 SIMD_CALL aa_of(floatx2 const ab) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shuffle_ps(ab.floats, ab.floats, 0b00'00) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { ab.floats[0], ab.floats[0] };
#	endif
}
floatx2 SIMD_CALL aa_of(floatx4 const abcd) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shuffle_ps(abcd.floats, abcd.floats, 0b00'00) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { abcd.floats[0], abcd.floats[0] };
#	endif
}

// Broadcasts lane [1]s value.
floatx2 SIMD_CALL bb_of(floatx2 const ab) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shuffle_ps(ab.floats, ab.floats, 0b01'01) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { ab.floats[1], ab.floats[1] };
#	endif
}
floatx2 SIMD_CALL bb_of(floatx4 const abcd) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shuffle_ps(abcd.floats, abcd.floats, 0b01'01) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { abcd.floats[1], abcd.floats[1] };
#	endif
}

// Extracts lanes [2] and [3].
floatx2 SIMD_CALL cd_of(floatx4 const abcd) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_movehl_ps(abcd.floats, abcd.floats) }; // one byte shorter than shuffling
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { abcd.floats[2], abcd.floats[3], abcd.floats[2], abcd.floats[3] };
#	endif
}

floatx2 SIMD_CALL operator *(floatx2 const a, floatx2 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_mul_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats * b.floats };
#	endif
}

floatx2 SIMD_CALL operator +(floatx2 const a, floatx2 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_add_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats + b.floats };
#	endif
}

floatx2 SIMD_CALL operator -(floatx2 const a, floatx2 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_sub_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats - b.floats };
#	endif
}



// Loads a vector of four 32-bit floating-point numbers from the given address. The address may be unaligned.
floatx4 SIMD_CALL loadx4(float const * toV) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_loadu_ps(toV) };
#	elif COMPILED_BY_CLANG
		// Just load 128 bits at once; this emits MOVUPS. Use a structure because of strict aliasing rules.
		struct Floatx4Load { floatx4 v; } __attribute__((__packed__, __may_alias__));
		return reinterpret_cast<Floatx4Load const *>(toV)->v;
#	elif COMPILED_BY_GCC
		return __builtin_ia32_loadups(toV);
#	endif
}
floatx4 SIMD_CALL xyz0From(float const * toXYZ) {
#	if COMPILED_BY_VISUAL_CPP
		auto const xy00 = _mm_loadl_pi(_mm_setzero_ps(), toXYZ);
		auto const z000 = _mm_load_ss(toXYZ + 2);
		return { _mm_movelh_ps(xy00, z000) }; // one byte shorter than SHUFPS
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXYZ[0], toXYZ[1], toXYZ[2], 0 };
#	endif
}
// Loads a vector of three 32-bit floating-point numbers from the given address. The address may be unaligned.
floatx4 SIMD_CALL xyzFrom(float const * toXYZ) {
	return xyz0From(toXYZ);
}
// Loads a vector of three 32-bit signed integers from the given address. The address may be unaligned.
SInt4Bx4 SIMD_CALL xyzFrom(SInt4B const * toXYZ) {
#	if COMPILED_BY_VISUAL_CPP
		// Interleave one 8-B load with one 4-B load.
		auto const xy00 = _mm_loadl_epi64(toXYZ);
		auto const z000 = _mm_cvtsi32_si128(toXYZ[2]);
		return { _mm_unpacklo_epi64(xy00, z000) }; // XYZ0
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXYZ[0], toXYZ[1], toXYZ[2], 0 };
#	endif
}
// Loads a vector of two 32-bit floating-point numbers from the given address. The address may be unaligned.
floatx4 SIMD_CALL xy00From(float const * toXY) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_loadl_pi(_mm_setzero_ps(), toXY) }; // XY00
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXY[0], toXY[1], 0, 0 };
#	endif
}
floatx4 SIMD_CALL xy__From(float x, float y) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_unpacklo_ps(x___From(x).floats, x___From(y).floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, y, 0, 0 };
#	endif
}
floatx4 SIMD_CALL xy00From(float x, float y) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set_ps(0, 0, y, x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, y, 0, 0 };
#	endif
}
SInt4Bx4 SIMD_CALL xy00From(SInt4B x, SInt4B y) {
#	if COMPILED_BY_VISUAL_CPP
#		if COMPILED_FOR_X86_64
			//  combine the two 32-bit integers into one 64-bit integer
			//  move the 64-bit integer from a general purpose register to a SSE register
			//  reinterpret as two 32-bit integers
			auto const yx = (UInt8B(UInt4B(y)) << 32) | UInt4B(x); // prevent sign extension
			return { _mm_cvtsi64x_si128(yx) };
#		else
			return { _mm_unpacklo_epi32(_mm_cvtsi32_si128(x), _mm_cvtsi32_si128(y)) };
#		endif
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, y, 0, 0 };
#	endif
}
floatx4 SIMD_CALL x0z0From(float x, float z) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set_ps(0, z, 0, x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, 0, z, 0 };
#	endif
}
// XYZW ABCD -> XYAB
floatx4 SIMD_CALL xyxyFrom(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_movelh_ps(a.floats, b.floats) }; // one byte shorter than SHUFPS
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats[0], a.floats[1], b.floats[0], b.floats[1] };
#	endif
}
SInt4Bx4 SIMD_CALL xyxyFrom(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_unpacklo_epi64(a.ints, b.ints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a[0], a[1], b[0], b[1] };
#	endif
}
// XYZW ABCD -> YXBA
floatx4 SIMD_CALL yxyxFrom(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shuffle_ps(a.floats, b.floats, (0 << 6) + (1 << 4) + (0 << 2) + (1 << 0)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats[1], a.floats[0], b.floats[1], b.floats[0] };
#	endif
}
// XYZW ABCD -> XYZD
floatx4 SIMD_CALL xyz_wFrom(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		auto const xyz0 = _mm_castsi128_ps(_mm_srli_si128(xmmAllBitsOne(), 4)); // make an all ones register and shift in 4 *bytes* of zeroes
		return selectedByBitmask(a, b, floatx4{ xyz0 });
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats[0], a.floats[1], a.floats[2], b.floats[3] };
#	endif
}
floatx4 SIMD_CALL xyzwFrom(float x, float y, float z, float w) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set_ps(w, z, y, x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, y, z, w };
#	endif
}
SInt4Bx4 SIMD_CALL xyzwFrom(SInt4B x, SInt4B y, SInt4B z, SInt4B w) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set_epi32(w, z, y, x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, y, z, w };
#	endif
}
floatx4 SIMD_CALL x___From(float x) {
#	if COMPILED_BY_VISUAL_CPP
		//  _mm_set_ss:   zeroes the upper three register lanes, therefore requires one extra register & instruction
		//  _mm_set_ps1:  should be just shuffling since x already is in a SSE register, but Visual C++ 2015 doesnt get it
		//  _mm_set_ps:   looks wasteful, but generates optimal code in many cases
		//  { x, x, x, x }: also waste with Visual C++ 2015
		return { _mm_set_ps(x, x, x, x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, x, x, x }; // x already is in a register, so just shuffle
#	endif
}
floatx4 SIMD_CALL x000From(float x) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set_ss(x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, 0, 0, 0 };
#	endif
}
SInt4Bx4 SIMD_CALL x000From(SInt4B x) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cvtsi32_si128(x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, 0, 0, 0 };
#	endif
}
floatx4 SIMD_CALL loadx4(float x) {
#	if COMPILED_BY_VISUAL_CPP
		//  _mm_set_ps1: should be just shuffling since x already is in a SSE register, but Visual C++ 2015 doesnt get it
		//  _mm_set_ps:  looks wasteful, but generates optimal code
		return { _mm_set_ps(x, x, x, x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, x, x, x };
#	endif
}
SInt4Bx4 SIMD_CALL xxxxFrom(SInt4B x) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set_epi32(x, x, x, x) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, x, x, x };
#	endif
}
floatx4 SIMD_CALL xy00From(doublex2 xy) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cvtpd_ps(xy) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { float(xy[0]), float(xy[1]), 0, 0 };
#	endif
}
// Loads two 8-bit integers from the given address and casts them to 32-bit integers. The address may be unaligned.
SInt4Bx4 SIMD_CALL xy00From(SInt1B const * toXY) {
#	if COMPILED_BY_VISUAL_CPP
		// There is no way to load less than 16 B at once, so just load the two B into a general purpose register and move to an SSE
		//  register from there.
		auto xy00000000000000 = _mm_cvtsi32_si128(*reinterpret_cast<UInt2B const *>(toXY));
		// Now interleave the numbers with the *most significant* bytes of 32-bit integers. The three other bytes are needless.
		auto xy000000 = _mm_unpacklo_epi8(xy00000000000000, xy00000000000000);
		auto xy00 = _mm_unpacklo_epi16(xy000000, xy000000);
		// Sign extension:
		return { _mm_srai_epi32(xy00, 24) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXY[0], toXY[1], 0, 0 };
#	endif
}
// Loads two 16-bit integers from the given address and casts them to 32-bit integers. The address may be unaligned.
SInt4Bx4 SIMD_CALL xy00From(UInt2B const * toXY) {
#	if COMPILED_BY_VISUAL_CPP
		// Load one 32-bit integer with both 16-bit values. Zero the upper lanes.
		auto const xy000000 = _mm_cvtsi32_si128(*reinterpret_cast<SInt4B const *>(toXY));
		// Interleave with the zero lanes to form 32-bit integers.
		return { _mm_shufflelo_epi16(xy000000, (3 << 6) + (1 << 4) + (2 << 2) + 0) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		// Load one 32-bit integer with both 16-bit values and cast it to eight 16-bit integers. This emits MOVD. Use a structure
		//  because of strict aliasing rules.
		struct SInt4BLoad { SInt4B data; } __attribute__((__packed__, __may_alias__));
		auto const xy000000 = (SInt2Bx8)(SInt4Bx4){ reinterpret_cast<SInt4BLoad const *>(toXY)->data, 0, 0, 0 };
		// Interleave with the zero lanes to form 32-bit integers.
		return __builtin_shufflevector(xy000000, xy000000, 0, 4, 1, 5, 2, 6, 3, 7);
#	endif
}
// Loads four 16-bit integers from the given address and casts them to 32-bit integers. The address may be unaligned.
SInt4Bx4 SIMD_CALL xyzwFrom(UInt2B const * toXYZW) {
#	if COMPILED_BY_VISUAL_CPP
		// Load one 64-bit integer with all four 16-bit values.
		auto const xyzw0000 = _mm_loadl_epi64(reinterpret_cast<SInt4B const *>(toXYZW));
		// Interleave the lower four lanes with 16 zero bits each.
		return { _mm_unpacklo_epi16(xyzw0000, _mm_setzero_si128()) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		// Load one 64-bit integer with all four 16-bit values and cast it to eight 16-bit integers. This emits MOVQ. Use a
		//  structure because of strict aliasing rules.
		struct SInt8BLoad { SInt8B data; } __attribute__((__packed__, __may_alias__));
		auto const xyzw0000 = (SInt2Bx8)(SInt8Bx2){ reinterpret_cast<SInt8BLoad const *>(toXYZW)->data, 0 };
		// Interleave the lower four lanes with 16 zero bits each.
		return __builtin_shufflevector(xyzw0000, xyzw0000, 0, 4, 1, 5, 2, 6, 3, 7);
#	endif
}
// Loads four 8-bit integers from the given 4 B (in memory order) and casts them to 32-bit integers.
SInt4Bx4 SIMD_CALL xyzwFrom(UInt4B xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		auto const xyzw000000000000 = _mm_cvtsi32_si128(xyzw);
		// Interleave with 24 zero bits each.
		return { _mm_unpacklo_epi16(_mm_unpacklo_epi8(xyzw000000000000, _mm_setzero_si128()), _mm_setzero_si128()) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw & 0xFF, (xyzw >> 8) & 0xFF, (xyzw >> 16) & 0xFF, (xyzw >> 24) };
#	endif
}
// Loads four 16-bit integers from the given address and casts them to 32-bit integers. The address may be unaligned.
SInt4Bx4 SIMD_CALL xyzwFrom(SInt2B const * toXYZW) {
#	if COMPILED_BY_VISUAL_CPP
		// Load one 64-bit integer with all four 16-bit values.
		auto const xyzw0000 = _mm_loadl_epi64(reinterpret_cast<SInt4B const *>(toXYZW));
		// Interleave the numbers to the *most significant* bytes of 32-bit integers. The two other bytes are needless.
		auto xyzw = _mm_unpacklo_epi16(xyzw0000, xyzw0000);
		// Sign extension:
		return { _mm_srai_epi32(xyzw, 16) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		// Load one 64-bit integer with all four 16-bit values and cast it to eight 16-bit integers. This emits MOVQ. Use a
		//  structure because of strict aliasing rules.
		struct SInt8BLoad { SInt8B data; } __attribute__((__packed__, __may_alias__));
		auto const xyzw0000 = (SInt2Bx8)(SInt8Bx2){ reinterpret_cast<SInt8BLoad const *>(toXYZW)->data, 0 };
		// Interleave with replicated sign bits. This pads negative lanes with 16 ones and positive lanes with 16 zeroes each.
		return __builtin_shufflevector(xyzw0000, __builtin_ia32_psrawi128(xyzw0000, 15), 0, 8, 1, 9, 2, 10, 3, 11);
#	endif
}
SInt4Bx4 SIMD_CALL xyz0From(SInt2B const * toXYZ) {
#	if COMPILED_BY_VISUAL_CPP
		// One 4-B load and one 2-B load.
		auto const xy000000 = _mm_cvtsi32_si128(*reinterpret_cast<SInt4B const *>(toXYZ));
		auto const z0000000 = _mm_cvtsi32_si128(UInt2B(toXYZ[2])); // prevent sign extension from polluting W
		auto const xyz00000 = _mm_unpacklo_epi32(xy000000, z0000000);
		// Interleave the numbers to the *most significant* bytes of 32-bit integers. The two other bytes are needless.
		auto xyz0 = _mm_unpacklo_epi16(xyz00000, xyz00000);
		// Sign extension:
		return { _mm_srai_epi32(xyz0, 16) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXYZ[0], toXYZ[1], toXYZ[2], 0 };
#	endif
}
SInt4Bx4 SIMD_CALL xy00From(SInt4B const * toXY) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_loadl_epi64(toXY) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXY[0], toXY[1], 0, 0 };
#	endif
}
UInt4B SIMD_CALL roundedToSInt1Bx4(floatx4 xyzw_float) {
	auto xyzw_int32 = rounded(xyzw_float);
#	if COMPILED_BY_VISUAL_CPP
		auto xyzw_int16 = _mm_packs_epi32(xyzw_int32.ints, xyzw_int32.ints); // Signed saturation!
		auto xyzw_int8  = _mm_packs_epi16(xyzw_int16, xyzw_int16); // Signed saturation!
		return UInt4B(_mm_cvtsi128_si32(xyzw_int8));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		auto xyzw_int16 = __builtin_ia32_packsswb128(xyzw_int32.ints, xyzw_int32.ints); // Signed saturation!
		auto xyzw_int8  = __builtin_ia32_packsswb128(xyzw_int16, xyzw_int16); // Signed saturation!
		union {
			SInt1Bx16 sInt1BX16;
			UInt4B    uInt4Bx1;
		} result;
		result.sInt1BX16.ints = xyzw_int8;
		return result.uInt4Bx1;
#	endif
}
// Rounds four floating-point numbers in the range of [01] to four integers in the range of [0255].
//   input below 0.0 clamps to 0; input above 1.0 clamps to 255
//   useful for color handling
UInt4B SIMD_CALL UNorm1Bx4From(floatx4 xyzw_float) {
	auto xyzw_uint8 = asUInt1B(rounded(loadx4(255.0f) * xyzw_float));
#	if COMPILED_BY_VISUAL_CPP
		return UInt4B(_mm_cvtsi128_si32(xyzw_uint8.uints));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		union {
			UInt1Bx4 uInt1BX4;
			UInt4B   dword;
		} result;
		result.uInt1BX4 = xyzw_uint8;
		return result.dword;
#	endif
}
// Casts all elements to 2-B unsigned integers.
//   all lanes must be in [0, 65 535] range
UInt2Bx4 SIMD_CALL asUInt2B(SInt4Bx4 const xyzw_int32) {
#	if COMPILED_BY_VISUAL_CPP
		MUST(0 <= xyzw_int32.ints.i32[0] && xyzw_int32.ints.i32[0] <= 65535
		  && 0 <= xyzw_int32.ints.i32[1] && xyzw_int32.ints.i32[1] <= 65535
		  && 0 <= xyzw_int32.ints.i32[2] && xyzw_int32.ints.i32[2] <= 65535
		  && 0 <= xyzw_int32.ints.i32[3] && xyzw_int32.ints.i32[3] <= 65535
		);
		return { _mm_packs_epi32(xyzw_int32.ints, xyzw_int32.ints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		MUST(0 <= xyzw_int32.ints[0] && xyzw_int32.ints[0] <= 65535
		  && 0 <= xyzw_int32.ints[1] && xyzw_int32.ints[1] <= 65535
		  && 0 <= xyzw_int32.ints[2] && xyzw_int32.ints[2] <= 65535
		  && 0 <= xyzw_int32.ints[3] && xyzw_int32.ints[3] <= 65535
		);
		return { xyzw_int32[0], xyzw_int32[1], xyzw_int32[2], xyzw_int32[3], xyzw_int32[0], xyzw_int32[1], xyzw_int32[2], xyzw_int32[3] }; // PACKSSDW
#	endif
}
doublex2 SIMD_CALL x0From(double x) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_set_sd(x);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, 0.0 };
#	endif
}
doublex2 SIMD_CALL xxFrom(double x) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_set1_pd(x);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, x };
#	endif
}
doublex2 SIMD_CALL xyFrom(double x, double y) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_set_pd(y, x);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { x, y };
#	endif
}
doublex2 SIMD_CALL xyFrom(double const * toXY) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_loadu_pd(toXY);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { toXY[0], toXY[1] };
#	endif
}
doublex2 SIMD_CALL xyFrom(SInt4B x, SInt4B y) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cvtepi32_pd(xy00From(x, y).ints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { double(x), double(y) };
#	endif
}
// Stores the X and Y lanes at the given address. The address may be unaligned.
void SIMD_CALL xTo(float * toX, floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_store_ss(toX, xyzw.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		*toX = xyzw.floats[0];
#	endif
}
void SIMD_CALL xTo(double * toX, doublex2 xy) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_store_sd(toX, xy);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		*toX = xy[0];
#	endif
}
// Stores the X and Y lanes at the given address. The address may be unaligned.
void SIMD_CALL xyTo(float * toXY, floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storel_pi(toXY, xyzw.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		__builtin_ia32_storelps((SInt4Bx2 *)toXY, xyzw.floats);
#	endif
}
void SIMD_CALL xyTo(double * toXY, doublex2 xy) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storeu_pd(toXY, xy);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		__builtin_ia32_storeupd((double *)toXY, xy);
#	endif
}
void SIMD_CALL xyTo(SInt2B * toXY, SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		auto xyzwxyzw = _mm_packs_epi32(xyzw.ints, xyzw.ints);
		*reinterpret_cast<UInt4B *>(toXY) = _mm_cvtsi128_si32(xyzwxyzw);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		toXY[0] = SInt2B(xyzw[0]);
		toXY[1] = SInt2B(xyzw[1]);
#	endif
}
void SIMD_CALL xyTo(SInt4B * toXY, SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storel_epi64(toXY, xyzw.ints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		toXY[0] = xyzw[0];
		toXY[1] = xyzw[1];
#	endif
}
// Stores the Z and W lanes at the given address. The address may be unaligned.
void SIMD_CALL zwTo(float * toZW, floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storeh_pi(toZW, xyzw.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		__builtin_ia32_storehps((SInt4Bx2 *)toZW, xyzw.floats);
#	endif
}
// Stores the X, Y, and Z lanes at the given address. The address may be unaligned.
void SIMD_CALL xyzTo(float * toXYZ, floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storel_pi(toXYZ, xyzw.floats);
		// MOVHLPS is just as fast as SHUFPS to replace X with Z, but one byte shorter.
		_mm_store_ss(toXYZ + 2, _mm_movehl_ps(xyzw.floats, xyzw.floats));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		__builtin_ia32_storelps((SInt4Bx2 *)toXYZ, xyzw.floats);
		toXYZ[2] = xyzw.floats[2];
#	endif
}
void SIMD_CALL xyzTo(SInt2B * toXYZ, SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		*reinterpret_cast<UInt4B *>(toXYZ) = _mm_cvtsi128_si32(_mm_shufflelo_epi16(xyzw.ints, (2 << 2) + 0));
		toXYZ[2] = SInt2B(_mm_cvtsi128_si32(_mm_unpackhi_epi32(xyzw.ints, xyzw.ints)));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		toXYZ[0] = SInt2B(xyzw[0]);
		toXYZ[1] = SInt2B(xyzw[1]);
		toXYZ[2] = SInt2B(xyzw[2]);
#	endif
}
void SIMD_CALL xyzTo(SInt4B * toXYZ, SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storel_epi64(toXYZ, xyzw.ints);
		toXYZ[2] = _mm_cvtsi128_si32(_mm_unpackhi_epi64(xyzw.ints, xyzw.ints));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		toXYZ[0] = xyzw[0];
		toXYZ[1] = xyzw[1];
		toXYZ[2] = xyzw[2];
#	endif
}
// Stores the X, Y, Z, and W lanes at the given address. The address may be unaligned.
void SIMD_CALL xyzwTo(float * toXYZW, floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storeu_ps(toXYZW, xyzw.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		__builtin_ia32_storeups(toXYZW, xyzw.floats);
#	endif
}

void SIMD_CALL xyzwTo(UInt2B * toXYZW, SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		auto xyzwxyzw = _mm_packs_epi32(xyzw.ints, xyzw.ints);
		_mm_storel_epi64(reinterpret_cast<SInt4B *>(toXYZW), xyzwxyzw);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		union {
			SInt4Bx4 dq;
			UInt2B   w[8];
		} xyzwxyzw = { __builtin_ia32_packssdw128(xyzw, xyzw) };
		toXYZW[0] = xyzwxyzw.w[0];
		toXYZW[1] = xyzwxyzw.w[1];
		toXYZW[2] = xyzwxyzw.w[2];
		toXYZW[3] = xyzwxyzw.w[3];
#	endif
}
void SIMD_CALL xyzwTo(SInt2B * toXYZW, SInt4Bx4 xyzw) {
	return xyzwTo((UInt2B *)toXYZW, xyzw);
}

float SIMD_CALL xOf(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(xyzw.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.floats[0];
#	endif
}
float SIMD_CALL yOf(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(y___Of(xyzw).floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.floats[1];
#	endif
}
float SIMD_CALL zOf(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(z___Of(xyzw).floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.floats[2];
#	endif
}
float SIMD_CALL wOf(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(wwwwOf(xyzw).floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.floats[3];
#	endif
}
double SIMD_CALL xOf(doublex2 xy) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsd_f64(xy);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xy[0];
#	endif
}
floatx4 SIMD_CALL x0y0Of(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_unpacklo_ps(xyzw.floats, _mm_setzero_ps()) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[0], 0, xyzw.floats[1], 0 };
#	endif
}
floatx4 SIMD_CALL xxxxOf(floatx4 xyzw) {
	return shuffled<0, 0, 0, 0>(xyzw);
}
floatx4 SIMD_CALL xxxyOf(floatx4 xyzw) {
	return shuffled<0, 0, 0, 1>(xyzw);
}
floatx4 SIMD_CALL xxyyOf(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_unpacklo_ps(xyzw.floats, xyzw.floats) }; // one byte shorter than shuffling
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[0], xyzw.floats[0], xyzw.floats[1], xyzw.floats[1] };
#	endif
}
floatx4 SIMD_CALL xy0_Of(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_movelh_ps(xyzw.floats, _mm_setzero_ps()) }; // one byte shorter than shuffling
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[0], xyzw.floats[1], 0, 0 };
#	endif
}
floatx4 SIMD_CALL xyxxOf(floatx4 xyzw) {
	return shuffled<0, 1, 0, 0>(xyzw);
}
floatx4 SIMD_CALL xyxyOf(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_movelh_ps(xyzw.floats, xyzw.floats) }; // one byte shorter than shuffling
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[0], xyzw.floats[1], xyzw.floats[0], xyzw.floats[1] };
#	endif
}
floatx4 SIMD_CALL xyyxOf(floatx4 xyzw) {
	return shuffled<0, 1, 1, 0>(xyzw);
}
floatx4 SIMD_CALL xyz0Of(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		auto xyz0 = _mm_srli_si128(xmmAllBitsOne(), 4); // make an all ones register and shift in 4 *bytes* of zeroes
		return { _mm_and_ps(xyzw.floats, _mm_castsi128_ps(xyz0)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[0], xyzw.floats[1], xyzw.floats[2], 0 };
#	endif
}
floatx4 SIMD_CALL xyz1Of(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		auto xyz0 = _mm_srli_si128(xmmAllBitsOne(), 4); // make an all ones register and shift in 4 *bytes* of zeroes
		// bit pattern of the 1.0f constant: two zeroes  seven ones  23 zeroes
		//   mask off X/Y/Z by shifting 12 *bytes* of zeroes into an all ones register
		//   shift in 25 zeroes from the left
		//   shift in 23 zeroes from the right
		auto OOO1 = _mm_castsi128_ps(_mm_slli_epi32(_mm_srli_epi32(_mm_slli_si128(xmmAllBitsOne(), 12), 25), 23));
		return { _mm_or_ps(_mm_and_ps(xyzw.floats, _mm_castsi128_ps(xyz0)), OOO1) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[0], xyzw.floats[1], xyzw.floats[2], 0 };
#	endif
}
floatx4 SIMD_CALL xyzxOf(floatx4 xyzw) {
	return shuffled<0, 1, 2, 0>(xyzw);
}
floatx4 SIMD_CALL xz__Of(floatx4 xyzw) {
	return xzzzOf(xyzw);
}
floatx4 SIMD_CALL xzywOf(floatx4 xyzw) {
	return shuffled<0, 2, 1, 3>(xyzw);
}
floatx4 SIMD_CALL xzzzOf(floatx4 xyzw) {
	return shuffled<0, 2, 2, 2>(xyzw);
}
floatx4 SIMD_CALL y___Of(floatx4 xyzw) {
	return shuffled<1, 1, 1, 1>(xyzw);
}
floatx4 SIMD_CALL y_w_Of(floatx4 xyzw) {
	return shuffled<1, 1, 3, 3>(xyzw);
}
floatx4 SIMD_CALL y000Of(floatx4 xyzw) {
	return shuffled<1, 2, 2, 2>(xy0_Of(xyzw));
}
floatx4 SIMD_CALL yx__Of(floatx4 xyzw) {
	return yxyxOf(xyzw);
}
floatx4 SIMD_CALL yx00Of(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shuffle_ps(xyzw.floats, _mm_setzero_ps(), (0 << 6) + (0 << 4) + (0 << 2) + 1) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[1], xyzw.floats[0], 0, 0 };
#	endif
}
floatx4 SIMD_CALL yxxyOf(floatx4 xyzw) {
	return shuffled<1, 0, 0, 1>(xyzw);
}
floatx4 SIMD_CALL yxyxOf(floatx4 xyzw) {
	return shuffled<1, 0, 1, 0>(xyzw);
}
floatx4 SIMD_CALL yyxxOf(floatx4 xyzw) {
	return shuffled<1, 1, 0, 0>(xyzw);
}
floatx4 SIMD_CALL yyyyOf(floatx4 xyzw) {
	return shuffled<1, 1, 1, 1>(xyzw);
}
floatx4 SIMD_CALL yz__Of(floatx4 xyzw) {
	return yzwxOf(xyzw);
}
floatx4 SIMD_CALL yzxzOf(floatx4 xyzw) {
	return shuffled<1, 2, 0, 2>(xyzw);
}
floatx4 SIMD_CALL yzxwOf(floatx4 xyzw) {
	return shuffled<1, 2, 0, 3>(xyzw);
}
floatx4 SIMD_CALL yzzyOf(floatx4 xyzw) {
	return shuffled<1, 2, 2, 1>(xyzw);
}
floatx4 SIMD_CALL yzwxOf(floatx4 xyzw) {
	return shuffled<1, 2, 3, 0>(xyzw);
}
floatx4 SIMD_CALL z___Of(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		// SHUFPS:   one byte longer than the other instructions
		// UNPCKHPS: limited to one execution port
		// MOVHLPS:  probably optimal
		return { _mm_movehl_ps(xyzw.floats, xyzw.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[2], xyzw.floats[3], xyzw.floats[2], xyzw.floats[3] };
#	endif
}
floatx4 SIMD_CALL zx__Of(floatx4 xyzw) {
	return shuffled<2, 0, 0, 0>(xyzw);
}
floatx4 SIMD_CALL zxyzOf(floatx4 xyzw) {
	return shuffled<2, 0, 1, 2>(xyzw);
}
floatx4 SIMD_CALL zxywOf(floatx4 xyzw) {
	return shuffled<2, 0, 1, 3>(xyzw);
}
floatx4 SIMD_CALL zxwyOf(floatx4 xyzw) {
	return shuffled<2, 0, 3, 1>(xyzw);
}
floatx4 SIMD_CALL zyxwOf(floatx4 xyzw) {
	return shuffled<2, 1, 0, 3>(xyzw);
}
floatx4 SIMD_CALL zyzzOf(floatx4 xyzw) {
	return shuffled<2, 1, 2, 2>(xyzw);
}
floatx4 SIMD_CALL zzxxOf(floatx4 xyzw) {
	return shuffled<2, 2, 0, 0>(xyzw);
}
floatx4 SIMD_CALL zzyyOf(floatx4 xyzw) {
	return shuffled<2, 2, 1, 1>(xyzw);
}
floatx4 SIMD_CALL zzzxOf(floatx4 xyzw) {
	return shuffled<2, 2, 2, 0>(xyzw);
}
floatx4 SIMD_CALL zzzzOf(floatx4 xyzw) {
	return shuffled<2, 2, 2, 2>(xyzw);
}
floatx4 SIMD_CALL zw__Of(floatx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_movehl_ps(xyzw.floats, xyzw.floats) }; // one byte shorter than shuffling
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyzw.floats[2], xyzw.floats[3], xyzw.floats[2], xyzw.floats[3] };
#	endif
}
floatx4 SIMD_CALL wz__Of(floatx4 xyzw) {
	return shuffled<3, 2, 1, 0>(xyzw);
}
floatx4 SIMD_CALL wwyxOf(floatx4 xyzw) {
	return shuffled<3, 3, 1, 0>(xyzw);
}
floatx4 SIMD_CALL wwwwOf(floatx4 xyzw) {
	return shuffled<3, 3, 3, 3>(xyzw);
}
SInt4Bx4 SIMD_CALL xzywOf(SInt4Bx4 xyzw) {
	return { SWIZZLED_INT4BX4(xyzw.ints, 0, 2, 1, 3) };
}
SInt4Bx4 SIMD_CALL yyyyOf(SInt4Bx4 xyzw) {
	return { SWIZZLED_INT4BX4(xyzw.ints, 1, 1, 1, 1) };
}
SInt4Bx4 SIMD_CALL zw__Of(SInt4Bx4 xyzw) {
	return { SWIZZLED_INT4BX4(xyzw.ints, 2, 3, 0, 1) };
}
SInt4Bx4 SIMD_CALL wwwwOf(SInt4Bx4 xyzw) {
	return { SWIZZLED_INT4BX4(xyzw.ints, 3, 3, 3, 3) };
}

// A mask for the sign bits of the floating-point numbers in the Y and W lane.
floatx4 SIMD_CALL floatx4SignMask_YW() {
#	if COMPILED_BY_VISUAL_CPP
		// 0xFFFFFFFFFFFFFFFF << 63 == 0x8000000000000000
		return { _mm_castsi128_ps(_mm_slli_epi64(xmmAllBitsOne(), 63)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { 0x00000000, 0x80000000, 0x00000000, 0x80000000 };
#	endif
}

floatx4 SIMD_CALL negatedZ(floatx4 xyzw) {
	return shuffled<0, 0, 1, 0>(floatx4SignMask_YW()) ^ xyzw;
}

SInt4B SIMD_CALL xOf(SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsi128_si32(xyzw.ints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.ints[0];
#	endif
}
SInt4B SIMD_CALL yOf(SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsi128_si32(yyyyOf(xyzw).ints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.ints[1];
#	endif
}
SInt4B SIMD_CALL zOf(SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		// PUNPCKHDQ is just as fast as PSHUFD to replace X with Z, but one byte shorter.
		return _mm_cvtsi128_si32(_mm_unpackhi_epi32(xyzw.ints, xyzw.ints));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.ints[2];
#	endif
}
SInt4B SIMD_CALL wOf(SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsi128_si32(wwwwOf(xyzw).ints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return xyzw.ints[3];
#	endif
}

// Converts the given 32-bit integers to 32-bit floating-point numbers.
floatx4 SIMD_CALL asFloats(SInt4Bx4 xyzw) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cvtepi32_ps(xyzw.ints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_cvtdq2ps(xyzw) };
#	endif
}
// Converts the given 32-bit floating-point numbers in the X and Y lane to 64-bit floating-point numbers.
doublex2 SIMD_CALL asDoubles(floatx4 xy__) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtps_pd(xy__.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_cvtps2pd(xy__.floats);
#	endif
}
// Converts the given 32-bit signed integers in the X and Y lane to 64-bit floating-point numbers.
doublex2 SIMD_CALL asDoubles(SInt4Bx4 xy__) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtepi32_pd(xy__.ints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_cvtdq2pd(xy__);
#	endif
}

floatx4 SIMD_CALL floatx4Zero() {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_setzero_ps() };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { 0 };
#	endif
}
SInt4Bx4 SIMD_CALL SInt4Bx4_zero() {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_setzero_si128() };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { 0 };
#	endif
}

floatx4 SIMD_CALL floatx4Infinity() {
#	if COMPILED_BY_VISUAL_CPP
		// 0xFFFFFFFF << 24 >> 1 == 0x7F800000 == +INF
		return { _mm_castsi128_ps(_mm_srli_epi32(_mm_slli_epi32(xmmAllBitsOne(), 24), 1)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { { INF_FLOAT4B, INF_FLOAT4B, INF_FLOAT4B, INF_FLOAT4B } };
#	endif
}

// A mask for the sign bits of all four floating-point numbers.
floatx4 SIMD_CALL floatx4SignMask_XYZW() {
#	if COMPILED_BY_VISUAL_CPP
		// 0xFFFFFFFF << 31 == 0x80000000
		return { _mm_castsi128_ps(_mm_slli_epi32(xmmAllBitsOne(), 31)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { { -0.0f, -0.0f, -0.0f, -0.0f } };
#	endif
}

// A mask for the sign bits of the floating-point numbers in the X and Z lane.
floatx4 SIMD_CALL floatx4SignMask_XZ() {
	return shuffled<1, 0, 1, 0>(floatx4SignMask_YW());
}

// A mask for the sign bit of the floating-point number in the X lane.
floatx4 SIMD_CALL floatx4SignMask_X() {
	return shuffled<1, 0, 0, 0>(floatx4SignMask_YW());
}

// A mask for the sign bit of the floating-point number in the Y lane.
floatx4 SIMD_CALL floatx4SignMask_Y() {
	return shuffled<0, 1, 0, 0>(floatx4SignMask_YW());
}

// A mask for the sign bit of the floating-point number in the Z lane.
floatx4 SIMD_CALL floatx4SignMask_Z() {
	return shuffled<0, 0, 1, 0>(floatx4SignMask_YW());
}

// A mask for the sign bit of the floating-point number in the W lane.
floatx4 SIMD_CALL floatx4SignMask_W() {
	return shuffled<0, 0, 0, 1>(floatx4SignMask_YW());
}

// Generates a mask for the sign bits of two IEEE754 floating-point numbers.
doublex2 SIMD_CALL doublex2SignMask() {
#	if COMPILED_BY_VISUAL_CPP
		// 0xFFFFFFFFFFFFFFFF << 63 == 0x8000000000000000
		return _mm_castsi128_pd(_mm_slli_epi64(xmmAllBitsOne(), 63));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return (SInt4Bx4){ 0x80000000, 0, 0x80000000, 0 };
#	endif
}

floatx4 SIMD_CALL operator +(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_add_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats + b.floats };
#	endif
}
floatx4 & SIMD_CALL operator +=(floatx4 & a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return a = { _mm_add_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a = { a.floats + b.floats };
#	endif
}
floatx4 SIMD_CALL operator -(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_sub_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats - b.floats };
#	endif
}
floatx4 & SIMD_CALL operator -=(floatx4 & a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return a = { _mm_sub_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a = { a.floats - b.floats };
#	endif
}
floatx4 SIMD_CALL operator *(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_mul_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats * b.floats };
#	endif
}
floatx4 & SIMD_CALL operator *=(floatx4 & a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return a = { _mm_mul_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a = { a.floats * b.floats };
#	endif
}
floatx4 SIMD_CALL operator /(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_div_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats / b.floats };
#	endif
}
floatx4 & SIMD_CALL operator /=(floatx4 & a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return a = { _mm_div_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a = { a.floats / b.floats };
#	endif
}
floatx4 SIMD_CALL operator &(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_and_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG
		return { IMPL_FLOATX4(IMPL_SINT4BX4(a.floats) & IMPL_SINT4BX4(b.floats)) };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_andps(a.floats, b.floats) };
#	endif
}
floatx4 SIMD_CALL operator |(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_or_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG
		return { IMPL_FLOATX4(IMPL_SINT4BX4(a.floats) | IMPL_SINT4BX4(b.floats)) };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_orps(a.floats, b.floats) };
#	endif
}
floatx4 SIMD_CALL operator ^(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_xor_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG
		return { IMPL_FLOATX4(IMPL_SINT4BX4(a.floats) ^ IMPL_SINT4BX4(b.floats)) };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_xorps(a.floats, b.floats) };
#	endif
}
#if COMPILED_BY_VISUAL_CPP // built-in on Clang & GCC
	doublex2 SIMD_CALL operator +(doublex2 a, doublex2 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return _mm_add_pd(a, b);
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return a + b;
	#	endif
	}
	doublex2 SIMD_CALL operator *(doublex2 a, doublex2 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return _mm_mul_pd(a, b);
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return a * b;
	#	endif
	}
	doublex2 SIMD_CALL operator &(doublex2 a, doublex2 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return _mm_and_pd(a, b);
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return __builtin_ia32_andpd(a, b);
	#	endif
	}
	SInt4Bx4 SIMD_CALL operator +(SInt4Bx4 a, SInt4Bx4 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return { _mm_add_epi32(a.ints, b.ints) };
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return { a + b };
	#	endif
	}
	SInt4Bx4 SIMD_CALL operator -(SInt4Bx4 a, SInt4Bx4 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return { _mm_sub_epi32(a.ints, b.ints) };
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return { a - b };
	#	endif
	}
	SInt4Bx4 & SIMD_CALL operator -=(SInt4Bx4 & a, SInt4Bx4 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return a = { _mm_sub_epi32(a.ints, b.ints) };
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return a = { a - b) };
	#	endif
	}
	SInt4Bx4 SIMD_CALL operator ^(SInt4Bx4 a, SInt4Bx4 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return { _mm_xor_si128(a.ints, b.ints) };
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return { a ^ b };
	#	endif
	}
	SInt4Bx4 SIMD_CALL operator &(SInt4Bx4 a, SInt4Bx4 b) {
	#	if COMPILED_BY_VISUAL_CPP
			return { _mm_and_si128(a.ints, b.ints) };
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return { a & b };
	#	endif
	}
	SInt4Bx4 SIMD_CALL operator <<(SInt4Bx4 a, UIntLeast1B const bits) {
		MUST(bits <= 31); // undefined otherwise
	#	if COMPILED_BY_VISUAL_CPP
			return { _mm_slli_epi32(a.ints, bits) };
	#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return { a << bits };
	#	endif
	}
#endif // COMPILED_BY_VISUAL_CPP

floatx4 SIMD_CALL andnot(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_andnot_ps(b.floats, a.floats) }; // Reverse order!
#	elif COMPILED_BY_CLANG
		return { IMPL_FLOATX4(IMPL_SINT4BX4(a.floats) & ~IMPL_SINT4BX4(b.floats)) };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_andnps(b.floats, a.floats) };
#	endif
}
SInt4Bx4 SIMD_CALL andnot(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_andnot_si128(b.ints, a.ints) }; // Reverse order!
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a & ~b };
#	endif
}
floatx4 SIMD_CALL minimumOf(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_min_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_minps(a.floats, b.floats) };
#	endif
}
floatx4 SIMD_CALL minimumOf(floatx4 a, floatx4 b, floatx4 c) {
	return minimumOf(minimumOf(a, b), c);
}
SInt4Bx4 SIMD_CALL minimumOf(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		// There is no minimum instructions for integer vectors. Instead:
		//   compare component-wise for b > a
		//   the registers are set entirely to 1 or 0 depending on the outcome
		//   (mask & a) | (~mask & b)
		auto mask = _mm_cmpgt_epi32(b.ints, a.ints);
		return { _mm_or_si128(_mm_and_si128(mask, a.ints), _mm_andnot_si128(mask, b.ints)) };
#	elif COMPILED_BY_CLANG
		auto mask = b > a;
		return { (mask & a) | (~mask & b) };
#	elif COMPILED_BY_GCC
		auto mask = __builtin_ia32_pcmpgtd128(b, a);
		return __builtin_ia32_por128(__builtin_ia32_pand128(mask, a), __builtin_ia32_pandn128(mask, b));
#	endif
}
doublex2 SIMD_CALL minimumOf(doublex2 a, doublex2 b) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_min_pd(a, b);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_minpd(a, b);
#	endif
}
floatx4 SIMD_CALL maximumOf(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_max_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_maxps(a.floats, b.floats) };
#	endif
}
floatx4 SIMD_CALL maximumOf(floatx4 a, floatx4 b, floatx4 c) {
	return maximumOf(maximumOf(a, b), c);
}
SInt4Bx4 SIMD_CALL maximumOf(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		// There is no maximum instructions for integer vectors. Instead:
		//   compare component-wise for a > b
		//   the registers are set entirely to 1 or 0 depending on the outcome
		//   (mask & a) | (~mask & b)
		auto mask = _mm_cmpgt_epi32(a.ints, b.ints);
		return { _mm_or_si128(_mm_and_si128(mask, a.ints), _mm_andnot_si128(mask, b.ints)) };
#	elif COMPILED_BY_CLANG
		auto mask = a > b;
		return { (mask & a) | (~mask & b) };
#	elif COMPILED_BY_GCC
		auto mask = __builtin_ia32_pcmpgtd128(a, b);
		return { __builtin_ia32_por128(__builtin_ia32_pand128(mask, a), __builtin_ia32_pandn128(mask, b)) };
#	endif
}
doublex2 SIMD_CALL maximumOf(doublex2 a, doublex2 b) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_max_pd(a, b);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_maxpd(a, b);
#	endif
}

// Broadcasts the greatest value in the vector.
//   returns all NaNs if any lane is NaN
floatx4 SIMD_CALL maximumOf(floatx4 const x_y_z_w) {
	auto const xy_yx_zw_wz = maximumOf(x_y_z_w, shuffled<1, 0, 2, 3>(x_y_z_w));
	return maximumOf(xy_yx_zw_wz, shuffled<3, 2, 1, 0>(xy_yx_zw_wz));
}

// Broadcasts the sum of all lanes.
floatx4 SIMD_CALL sumOf(floatx4 xyzw) {
	auto yxwz        = shuffled<1, 0, 3, 2>(xyzw);
	auto xy_yx_zw_wz = xyzw + yxwz;
	auto wz_zw_yx_xy = shuffled<3, 2, 1, 0>(xy_yx_zw_wz);
	return xy_yx_zw_wz + wz_zw_yx_xy;
}

// Merges a and b according to the given bitmask.
//   picks bits from a if the according mask bit is set, and from b otherwise
floatx4 SIMD_CALL selectedByBitmask(floatx4 a, floatx4 b, floatx4 mask) {
	return (a & mask) | andnot(b, mask);
}

// Returns each lanes sign bit.
local int SIMD_CALL signBitsOf(floatx4 abcd) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_movemask_ps(abcd.floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_movmskps(abcd.floats);
#	endif
}

// Shifts each lanes value to the right.
//   shifts in zeroes
//   shift must not exceed 31 bits
SInt4Bx4 SIMD_CALL shiftRightLogical(SInt4Bx4 xyzw, UIntLeast1B count) {
	MUST(count <= 31);
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_srli_epi32(xyzw.ints, int(count)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_psrldi128(xyzw, int(count)) };
#	endif
}

// Casts all elements to 1-B unsigned integers.
//   all lanes must be in [0, 255] range
UInt1Bx4 SIMD_CALL asUInt1B(SInt4Bx4 const xyzw_int32) {
#	if COMPILED_BY_VISUAL_CPP
		MUST(0 <= xyzw_int32.ints.i32[0] && xyzw_int32.ints.i32[0] <= 255
		  && 0 <= xyzw_int32.ints.i32[1] && xyzw_int32.ints.i32[1] <= 255
		  && 0 <= xyzw_int32.ints.i32[2] && xyzw_int32.ints.i32[2] <= 255
		  && 0 <= xyzw_int32.ints.i32[3] && xyzw_int32.ints.i32[3] <= 255
		);
		auto const xyzw_int16 = _mm_packs_epi32(xyzw_int32.ints, xyzw_int32.ints); // saturation is arbitrary (unsigned requires SSE 4.1)
		auto const xyzw_int8  = _mm_packus_epi16(xyzw_int16, xyzw_int16); // Unsigned saturation!
		return { xyzw_int8 };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		MUST(0 <= xyzw_int32.ints.i32[0] && xyzw_int32.ints.i32[0] <= 255
		  && 0 <= xyzw_int32.ints.i32[1] && xyzw_int32.ints.i32[1] <= 255
		  && 0 <= xyzw_int32.ints.i32[2] && xyzw_int32.ints.i32[2] <= 255
		  && 0 <= xyzw_int32.ints.i32[3] && xyzw_int32.ints.i32[3] <= 255
		);
		auto xyzw_int16 = __builtin_ia32_packsswb128(xyzw_int32.ints, xyzw_int32.ints); // saturation is arbitrary (unsigned requires SSE 4.1)
		auto xyzw_int8  = __builtin_ia32_packuswb128(xyzw_int16, xyzw_int16); // Unsigned saturation!
		return { { xyzw_int8[0], xyzw_int8[1], xyzw_int8[2], xyzw_int8[3] } };
#	endif
}

// X + Y (in first lane only!)
floatx4 SIMD_CALL sumOfXY(floatx4 xy__) {
#	if COMPILED_BY_VISUAL_CPP
		return xy__ + shuffled<1, 0, 1, 1>(xy__);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xy__.floats[0] + xy__.floats[1] };
#	endif
}
// X + Y + Z (in first lane only!)
floatx4 SIMD_CALL sumOfXYZ(floatx4 xyz_) {
#	if COMPILED_BY_VISUAL_CPP
		return xyz_ + floatx4 { _mm_add_ps(shuffled<1, 1, 1, 1>(xyz_).floats, _mm_movehl_ps(xyz_.floats, xyz_.floats)) }; // MOVHLPS is one byte shorter than SHUFPS
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { xyz_.floats[0] + xyz_.floats[1] + xyz_.floats[2] };
#	endif
}
// XYZW ABCD -> XAYB
floatx4 SIMD_CALL interleavedXY(floatx4 a, floatx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_unpacklo_ps(a.floats, b.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.floats[0], b.floats[0], a.floats[1], b.floats[1] };
#	endif
}

bool SIMD_CALL equalXY(floatx4 a, floatx4 b) {
	return 0b11 == (0b11 & signBitsOf(mask_isEqual(a, b)));
}
bool SIMD_CALL equalXY(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return 0xFF == (0xFF & _mm_movemask_epi8(_mm_cmpeq_epi32(a.ints, b.ints))); // returns the bits ________11111111 if X and Y equal
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a[0] == b[0] && a[1] == b[1];
#	endif
}
bool SIMD_CALL isNonZero_xOrYOrZ(floatx4 a) {
	return 0 != (0b111 & signBitsOf(mask_isNotEqual(a, floatx4Zero())));
}
bool SIMD_CALL equalXYZ(floatx4 a, floatx4 b) {
	return 0b111 == (0b111 & signBitsOf(mask_isEqual(a, b)));
}
bool SIMD_CALL equalXYZ(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return 0xFFF == (0xFFF & _mm_movemask_epi8(_mm_cmpeq_epi32(a.ints, b.ints))); // returns the bits ____111111111111 if X, Y, and Z equal
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a[0] == b[0] && a[1] == b[1] && a[2] == b[2];
#	endif
}
bool SIMD_CALL equalXYZW(floatx4 a, floatx4 b) {
	return 0b1111 == signBitsOf(mask_isEqual(a, b));
}
bool SIMD_CALL xyBelow(floatx4 a, floatx4 b) {
	return 0b11 == (0b11 & signBitsOf(mask_isLower(a, b)));
}
bool SIMD_CALL xyBelow(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return 0xFF == (0xFF & _mm_movemask_epi8(_mm_cmpgt_epi32(b.ints, a.ints))); // returns the bits ________11111111 if X and Y are lower than
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a[0] < b[0] && a[1] < b[1];
#	endif
}
bool SIMD_CALL xyzBelow(floatx4 a, floatx4 b) {
	return 0b111 == (0b111 & signBitsOf(mask_isLower(a, b)));
}
bool SIMD_CALL xyzBelow(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return 0xFFF == (0xFFF & _mm_movemask_epi8(_mm_cmplt_epi32(a.ints, b.ints))); // returns the bits ____'1111'1111'1111 if X, Y, and Z are lower than
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a[0] < b[0] && a[1] < b[1] && a[2] < b[2];
#	endif
}
bool SIMD_CALL xyzLowerOrEqual(floatx4 a, floatx4 b) {
	return 0b111 == (0b111 & signBitsOf(mask_isLowerOrEqual(a, b)));
}
bool SIMD_CALL xyzLowerOrEqual(SInt4Bx4 a, SInt4Bx4 b) {
#	if COMPILED_BY_VISUAL_CPP
		return 0x000 == (0xFFF & _mm_movemask_epi8(_mm_cmpgt_epi32(a.ints, b.ints))); // returns the bits ____'1111'1111'1111 if X, Y, and Z are greater
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return a[0] <= b[0] && a[1] <= b[1] && a[2] <= b[2];
#	endif
}

bool SIMD_CALL xyzWithin(
	SInt4B const   lowerLimit,
	SInt4Bx4 const xyz_,
	SInt4B const   upperLimit
) {
	MUST(lowerLimit <= upperLimit);
	auto const lowerLimits = xxxxFrom(lowerLimit);
	auto const upperLimits = xxxxFrom(upperLimit);
#	if COMPILED_BY_VISUAL_CPP
		auto const mask_zeroIfWithin = _mm_or_si128(_mm_cmplt_epi32(xyz_.ints, lowerLimits.ints), _mm_cmpgt_epi32(xyz_.ints, upperLimits.ints));
		return 0x000 == (0xFFF & _mm_movemask_epi8(mask_zeroIfWithin));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return lowerLimit <= x[0] && x[0] <= upperLimit
		    && lowerLimit <= x[1] && x[1] <= upperLimit
		    && lowerLimit <= x[2] && x[2] <= upperLimit;
#	endif
}

bool SIMD_CALL xyzWithin(int lowerLimit, SInt4Bx4, int upperLimit);

bool isWithin(
	UInt1B lowerLimit,
	UInt1B value,
	UInt1B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return (value - lowerLimit) <= (upperLimit - lowerLimit); // C++ wraps unsigned integer overruns with 2s complement
}

bool isWithin(
	UInt2B lowerLimit,
	UInt2B value,
	UInt2B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return (value - lowerLimit) <= (upperLimit - lowerLimit); // C++ wraps unsigned integer overruns with 2s complement
}

bool isWithin(
	UInt4B lowerLimit,
	UInt4B value,
	UInt4B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return (value - lowerLimit) <= (upperLimit - lowerLimit); // C++ wraps unsigned integer overruns with 2s complement
}

bool isWithin(
	UInt8B lowerLimit,
	UInt8B value,
	UInt8B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return (value - lowerLimit) <= (upperLimit - lowerLimit); // C++ wraps unsigned integer overruns with 2s complement
}

bool isWithin(
	SInt1B lowerLimit,
	SInt1B value,
	SInt1B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return lowerLimit <= value && value <= upperLimit;
}

bool isWithin(
	SInt2B lowerLimit,
	SInt2B value,
	SInt2B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return lowerLimit <= value && value <= upperLimit;
}

bool isWithin(
	SInt4B lowerLimit,
	SInt4B value,
	SInt4B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return lowerLimit <= value && value <= upperLimit;
}

bool SIMD_CALL isWithin(
	SInt4Bx4 lowerLimit,
	SInt4Bx4 value,
	SInt4Bx4 upperLimit
) {
	//  the 2s complement optimization does not work here because SSE2 has no unsigned comparisons
	//  there is no lower than or equal or greater than or equal in SSE2 (only greater than), so the test must be rewritten:
	//     NOT (lower > value OR value > upper)
#	if COMPILED_BY_VISUAL_CPP
		MUST(0 == _mm_movemask_epi8(_mm_cmpgt_epi32(lowerLimit.ints, upperLimit.ints))); // no lane of lowerLimit must exceed upperLimit
		return 0 == _mm_movemask_epi8(_mm_or_si128(_mm_cmpgt_epi32(lowerLimit.ints, value.ints), _mm_cmpgt_epi32(value.ints, upperLimit.ints)));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		MUST(lowerLimit[0] <= upperLimit[0] && lowerLimit[1] <= upperLimit[1] && lowerLimit[2] <= upperLimit[2] && lowerLimit[3] <= upperLimit[3]);
		return lowerLimit[0] <= value[0] && lowerLimit[1] <= value[1] && lowerLimit[2] <= value[2] && lowerLimit[3] <= value[3]
		    && value[0] <= upperLimit[0] && value[1] <= upperLimit[1] && value[2] <= upperLimit[2] && value[3] <= upperLimit[3];
#	endif
}

bool isWithin(
	SInt8B lowerLimit,
	SInt8B value,
	SInt8B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return lowerLimit <= value && value <= upperLimit;
}

float minimumOf(float a, float b) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(_mm_min_ps(x___From(a).floats, x___From(b).floats)); // branchless minimum via SSEs MINPS instruction
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_minss(x___From(a).floats, x___From(b).floats)[0];
#	endif
}
float minimumOf(float a, float b, float c) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(_mm_min_ps(_mm_min_ps(x___From(a).floats, x___From(b).floats), x___From(c).floats)); // branchless minimum via SSEs MINPS instruction
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_minss(__builtin_ia32_minss(x___From(a).floats, x___From(b).floats), x___From(c).floats)[0];
#	endif
}
double minimumOf(double a, double b) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsd_f64(_mm_min_pd(_mm_set_sd(a), _mm_set_sd(b))); // branchless minimum via SSEs MINPD instruction
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_minsd(x0From(a), x0From(b))[0];
#	endif
}

float maximumOf(float a, float b) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(_mm_max_ps(x___From(a).floats, x___From(b).floats)); // branchless maximum via SSEs MAXPS instruction
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_maxss(x___From(a).floats, x___From(b).floats)[0];
#	endif
}
float maximumOf(float a, float b, float c) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtss_f32(_mm_max_ps(_mm_max_ps(x___From(a).floats, x___From(b).floats), x___From(c).floats)); // branchless minimum via SSEs MAXPS instruction
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_maxss(__builtin_ia32_maxss(x___From(a).floats, x___From(b).floats), x___From(c).floats)[0];
#	endif
}
double maximumOf(double a, double b) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsd_f64(_mm_max_pd(_mm_set_sd(a), _mm_set_sd(b))); // branchless maximum via SSEs MAXSD instruction
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_maxsd(x0From(a), x0From(b))[0];
#	endif
}

// Clamps the given value to the given range.
UInt4B clamped(
	UInt4B lowerLimit,
	UInt4B value,
	UInt4B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	if(value < lowerLimit) {
		return lowerLimit;
	} else if(upperLimit < value) {
		return upperLimit;
	} else {
		return value;
	}
}
SInt4B clamped(
	SInt4B lowerLimit,
	SInt4B value,
	SInt4B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	if(value < lowerLimit) {
		return lowerLimit;
	} else if(upperLimit < value) {
		return upperLimit;
	} else {
		return value;
	}
}
UInt8B clamped(
	UInt8B lowerLimit,
	UInt8B value,
	UInt8B upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	if(value < lowerLimit) {
		return lowerLimit;
	} else if(upperLimit < value) {
		return upperLimit;
	} else {
		return value;
	}
}
float clamped(
	float lowerLimit,
	float value,
	float upperLimit
) {
	MUST(lowerLimit <= upperLimit);

#	if COMPILED_BY_VISUAL_CPP
		// Branchless clamping via SSEs MINPS/MAXPS instructions:
		return _mm_cvtss_f32(_mm_max_ps(x___From(lowerLimit).floats, _mm_min_ps(x___From(value).floats, x___From(upperLimit).floats)));
#	else
		return minimumOf(maximumOf(lowerLimit, value), upperLimit);
#	endif
}
floatx4 SIMD_CALL clamped(
	floatx4 lowerLimit,
	floatx4 value,
	floatx4 upperLimit
) {
	MUST(areAllLanesLowerOrEqual(lowerLimit, upperLimit));

	return minimumOf(maximumOf(lowerLimit, value), upperLimit);
}
double clamped(
	double lowerLimit,
	double value,
	double upperLimit
) {
	MUST(lowerLimit <= upperLimit);

	return minimumOf(maximumOf(lowerLimit, value), upperLimit);
}

float absoluteOf(float value) {
	// Use the SIMD version:
	//   1. the value can be found in a SSE register anyway
	//   2. the vector instruction is one byte shorter than the scalar instruction
	return xOf(absoluteOf(x___From(value)));
}
floatx4 SIMD_CALL absoluteOf(floatx4 const v) {
	return andnot(v, floatx4SignMask_XYZW());
}
double absoluteOf(double value) {
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsd_f64(_mm_andnot_pd(doublex2SignMask(), _mm_set_sd(value)));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_fabs(value);
#	endif
}
SInt4Bx4 SIMD_CALL absoluteOf(SInt4Bx4 value) {
	// See Sean Eron Anderson, Bit Twiddling Hacks  Compute the integer absolute value (abs) without branching.
#	if COMPILED_BY_VISUAL_CPP
		return (value + shiftRightArithmetic(value, 31)) ^ shiftRightArithmetic(value, 31);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return (value + __builtin_ia32_psradi128(value, 31)) ^ __builtin_ia32_psradi128(value, 31);
#	endif
}
UInt1B absoluteOf(SInt1B value) {
	// See Sean Eron Anderson, Bit Twiddling Hacks  Compute the integer absolute value (abs) without branching.
	return UInt1B((value + shiftRightArithmetic(value, 7)) ^ shiftRightArithmetic(value, 7));
}
UInt2B absoluteOf(SInt2B value) {
	// See Sean Eron Anderson, Bit Twiddling Hacks  Compute the integer absolute value (abs) without branching.
	return UInt2B((value + shiftRightArithmetic(value, 15)) ^ shiftRightArithmetic(value, 15));
}
UInt4B absoluteOf(SInt4B value) {
	// See Sean Eron Anderson, Bit Twiddling Hacks  Compute the integer absolute value (abs) without branching.
	return UInt4B((value + shiftRightArithmetic(value, 31)) ^ shiftRightArithmetic(value, 31));
}
UInt8B absoluteOf(SInt8B value) {
	// See Sean Eron Anderson, Bit Twiddling Hacks  Compute the integer absolute value (abs) without branching.
	return UInt8B((value + shiftRightArithmetic(value, 63)) ^ shiftRightArithmetic(value, 63));
}

// Returns no for any kind of NaN, but yes for infinities.
bool isNumber(float value) {
	return value == value; // NaN comparisons return no, even NaN to itself
}
bool isNumber(double value) {
	return value == value; // NaN comparisons return no, even NaN to itself
}

// no for positive or negative infinity and any kind of NaN.
bool isFinite(float value) {
	return absoluteOf(value) < INF_FLOAT4B; // any NaN comparison always returns no
}
bool isFinite(double value) {
	return absoluteOf(value) < INF_FLOAT8B; // any NaN comparison always returns no
}

// Returns a bit mask per lane:
//   1 where left < right
//   0 where left >= right
//   0 where either side is NaN
floatx4 SIMD_CALL mask_isLower(floatx4 l, floatx4 r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmplt_ps(l.floats, r.floats) };
#	elif COMPILED_BY_CLANG
		return { l.floats < r.floats };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpltps(l, r) };
#	endif
}

// Returns a bit mask per lane:
//   1 where left <= right
//   0 where left > right
//   0 where either side is NaN
floatx4 SIMD_CALL mask_isLowerOrEqual(floatx4 l, floatx4 r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmple_ps(l.floats, r.floats) };
#	elif COMPILED_BY_CLANG
		return { l.floats < r.floats };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpleps(l, r) };
#	endif
}

// Returns a bit mask per lane:
//   1 where left == right
//   0 where left != right
//   0 where either side is NaN
floatx4 SIMD_CALL mask_isEqual(floatx4 l, floatx4 r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmpeq_ps(l.floats, r.floats) };
#	elif COMPILED_BY_CLANG
		return { l.floats == r.floats };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpeqps(l, r) };
#	endif
}

// Returns a bit mask per lane:
//   1 where left != right
//   0 where left == right
//   0 where either side is NaN
floatx4 SIMD_CALL mask_isNotEqual(floatx4 l, floatx4 r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmpneq_ps(l.floats, r.floats) };
#	elif COMPILED_BY_CLANG
		return { l.floats != r.floats };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpneqps(l, r) };
#	endif
}

// Returns a bit mask per lane:
//   1 where left > right
//   0 where left <= right
//   0 where either side is NaN
floatx4 SIMD_CALL mask_isGreater(floatx4 l, floatx4 r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmpgt_ps(l.floats, r.floats) };
#	elif COMPILED_BY_CLANG
		return { l.floats > r.floats };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpgtps(l, r) };
#	endif
}

//  no for NaN
bool SIMD_CALL areAllLanesFinite(floatx4 const v) {
	return areAllLanesLower(absoluteOf(v), INF_FLOAT4B); // NaN comparisons always returns no
}

// Returns a bit mask per lane:
//   1 where finite
//   0 where NaN/infinite
floatx4 SIMD_CALL mask_isFinite(floatx4 abcd) {
	return mask_isLower(absoluteOf(abcd), loadx4(INF_FLOAT4B));
}

//  no for negative zero or NaN
bool SIMD_CALL areAllLanesPositive(floatx4 value) {
	auto const isNegativeMask = floatx4SignMask_XYZW() & value;
	return 0 == signBitsOf(isNegativeMask);
}

//  no for NaN
bool SIMD_CALL isAnyLaneGreater(floatx4 a, floatx4 b) {
	return 0 != signBitsOf(mask_isGreater(a, b));
}
bool SIMD_CALL isAnyLaneGreater(floatx4 a, float b) {
	return 0 != signBitsOf(mask_isGreater(a, loadx4(b)));
}

//  no for NaN
bool SIMD_CALL areAllLanesLower(floatx4 l, floatx4 r) {
	return 0b1111 == signBitsOf(mask_isLower(l, r));
}
bool SIMD_CALL areAllLanesLower(floatx4 l, float r) {
	return 0b1111 == signBitsOf(mask_isLower(l, loadx4(r)));
}

//  no for NaN
bool SIMD_CALL areAllLanesLowerOrEqual(floatx4 l, floatx4 r) {
	return 0b1111 == signBitsOf(mask_isLowerOrEqual(l, r));
}
bool SIMD_CALL areAllLanesLowerOrEqual(floatx4 l, float r) {
	return 0b1111 == signBitsOf(mask_isLowerOrEqual(l, loadx4(r)));
}

//  no for NaN
bool SIMD_CALL areAllLanesWithin(float const lowerLimit, floatx4 const abcd, float const upperLimit) {
	return 0b1111 == signBitsOf(mask_isLowerOrEqual(loadx4(lowerLimit), abcd) & mask_isLowerOrEqual(abcd, loadx4(upperLimit)));
}

// yes for subnormal floating-point numbers but not for zero.
bool isSubnormal(float value) {
	return -1.17549e-38f < value && value < 1.17549e-38f && 0.0f != value;
}
// Checks if X, Y, or Z contains a subnormal, non-zero floating-point number.
bool SIMD_CALL isSubnormal_xOrYOrZ(floatx4 xyzw) {
	// Create three bit masks:
	//   1. set if a lane is greater than the smallest (negative) normalized value
	//       Do NOT compare to smallest subnormalized (performance impact), use normalized instead!
	//       swap operands in order to use lower than only
	//   2. set if a lane is lower than the largest (positive) normalized value
	//       Do NOT compare to largest subnormalized (performance impact), use normalized instead!
	//   3. set if a lane is zero
	//       Use a floating-point comparison, NO bitwise comparison (negative zero problems)!
	// Combine them via bitwise AND. Lanes are set only for denormals.
	auto const validNegative = loadx4(-1.1755e-38f);
	auto const validPositive = loadx4(+1.1755e-38f);
	auto const zero          = floatx4Zero();
#	if COMPILED_BY_VISUAL_CPP
		auto const mask1 = mask_isLower(validNegative, xyzw);
		auto const mask2 = mask_isLower(xyzw, validPositive);
		auto const mask3 = mask_isEqual(xyzw, zero);
		auto const mask  = floatx4{ _mm_andnot_ps(mask3.floats, _mm_and_ps(mask1.floats, mask2.floats)) };
#	elif COMPILED_BY_CLANG
		auto const    mask1 = validNegative.floats < xyzw.floats;
		auto const    mask2 = xyzw.floats < validPositive.floats;
		auto const    mask3 = xyzw.floats == zero.floats;
		floatx4 const mask  = { IMPL_FLOATX4(mask1 & mask2 & ~mask3) };
#	elif COMPILED_BY_GCC
		auto const mask1 = mask_isLower(validNegative, xyzw);
		auto const mask2 = mask_isLower(xyzw, validPositive);
		auto const mask3 = mask_isEqual(xyzw, zero);
		auto const mask  = __builtin_ia32_andnps(mask3, __builtin_ia32_andps(mask1, mask2));
#	endif
	return 0 != (0b111 & signBitsOf(mask));
}

//  Are both operands positive?
//  Are both operands negative?
//  Is one or both operands zero (because zeros sign is pointless)?
bool sameSign(float a, float b) {
	return 0 <= a * b;
}

float doubled(float const value) {
	//  addition is thrice as fast as multiplication by two
	//  works entirely on registers (no cache miss accessing a constant)
	return value + value;
}
floatx4 SIMD_CALL doubled(floatx4 const v) {
	//  addition is thrice as fast as multiplication by two
	//  works entirely on registers (no cache miss accessing a constant)
	return v + v;
}
double doubled(double const value) {
	//  addition is thrice as fast as multiplication by two
	//  works entirely on registers (no cache miss accessing a constant)
	return value + value;
}
SInt4B doubled(SInt4B const value) {
	//  let the compiler decide
	//    three possible optimizations:
	//      1. left-shift
	//      2. addition
	//      3. address computation (LEA on x86)
	//    right choice depends heavily on context (instruction port workload)
	return 2 * value;
}
UInt4B doubled(UInt4B const value) {
	//  let the compiler decide
	//    three possible optimizations:
	//      1. left-shift
	//      2. addition
	//      3. address computation (LEA on x86)
	//    right choice depends heavily on context (instruction port workload)
	return 2 * value;
}
UInt8B doubled(UInt8B const  value) {
	//  let the compiler decide
	//    three possible optimizations:
	//      1. left-shift
	//      2. addition
	//      3. address computation (LEA on x86)
	//    right choice depends heavily on context (instruction port workload)
	//  Do NOT write a multiplication!
	//    on 32-bit builds, causes a dependency on the compilers 64-bit math emulation
	//      _ullmul() in MSVCP150.DLL with Visual C++ 2017
	return value + value;
}

// Rounds to integer.
//   must be in [-2 147 483 648, +2 147 483 520] range
//     deviation from signed 4-B integer minimum/maximum is due to floating-point accuracy
SInt4B rounded(float const value) {
	MUST(-2'147'483'648.0f <= value && value <= 2'147'483'520.0f);

	//  SSE2 offers scalar bankers round via CVTSS2SI
	//  Visual C++: only available via _mm_cvt_ss2si() intrinsic
	//  Clang/GCC: only available via __builtin_ia32_cvtss2si()
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvt_ss2si(x___From(value).floats);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_cvtss2si(x___From(value).floats);
#	endif
}

// Rounds to integer.
//   all lanes must be in [-2 147 483 648, +2 147 483 520] range
//     deviation from signed 4-B integer minimum/maximum is due to floating-point accuracy
SInt4Bx4 SIMD_CALL rounded(floatx4 const abcd) {
	MUST(areAllLanesWithin(-2'147'483'648.0f, abcd, 2'147'483'520.0f));

	//  SSE2 offers parallel bankers round via CVTPS2DQ
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cvtps_epi32(abcd.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_cvtps2dq(abcd.floats) };
#	endif
}

// Rounds the given IEEE754 double-precision floating-point number to a four-byte signed integer. Over- and underruns are
//  undefined.
SInt4B rounded(double value) {
	MUST(-2'147'483'648.0f <= value && value <= 2'147'483'647.0f);

	//  SSE2 offers scalar bankers round via CVTSD2SI
#	if COMPILED_BY_VISUAL_CPP
		return _mm_cvtsd_si32(_mm_set_sd(value));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_ia32_cvtsd2si(x0From(value));
#	endif
}
// Rounds the given IEEE754 double-precision floating-point number to an 8-B signed integer. Over- and underruns are undefined.
SInt8B roundedTo8B(float value) {
	MUST(-9'223'372'036'854'775'808.0f <= value && value <= 9'223'372'036'854'775'807.0f);

#	if COMPILED_FOR_X86_64
		// Use x64s CVTSS2SI instruction.
#		if COMPILED_BY_VISUAL_CPP
			return _mm_cvtss_si64x(_mm_set_ss(value));
#		elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return __builtin_ia32_cvtss2si64(x000From(value).floats);
#		endif
#	else
		return value > 0 ? SInt8B(value + 0.5f) : SInt8B(value - 0.5f);
#	endif
}
// Rounds the given IEEE754 double-precision floating-point number to an 8-B signed integer. Over- and underruns are undefined.
SInt8B roundedTo8B(double value) {
	MUST(-9'223'372'036'854'775'807.0f <= value && value <= 9'223'372'036'854'775'807.0f);

#	if COMPILED_FOR_X86_64
		// Use x64s CVTSD2SI instruction.
#		if COMPILED_BY_VISUAL_CPP
			return _mm_cvtsd_si64x(_mm_set_sd(value));
#		elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			return __builtin_ia32_cvtsd2si64(x0From(value));
#		endif
#	else
		return value > 0 ? SInt8B(value + 0.5) : SInt8B(value - 0.5);
#	endif
}

// Converts to integer by rounding towards negative infinity.
//   all lanes must be in [-2 147 483 648, +2 147 483 520] range
//     deviation from signed 4-B integer maximum is due to floating-point accuracy
SInt4Bx4 SIMD_CALL floored(floatx4 const abcd) {
	MUST(areAllLanesWithin(-2'147'483'648.0f, abcd, 2'147'483'520.0f));

	//  there is no floor instruction in SSE2 (was introduced with SSE4.1)
	//  use truncation (available with SSE2) and subtract one if the truncated value is greater than the original value
	//    requires a float-int-float roundtrip (slow!)
	//    but there is no other way
	auto const abcd_truncated = truncated(abcd);
	auto const maskGreater    = mask_isGreater(asFloats(abcd_truncated), abcd);
	auto const oneIfGreater   = shiftRightLogical(
#	if COMPILED_BY_VISUAL_CPP
		SInt4Bx4{ _mm_castps_si128(maskGreater.floats) },
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		SInt4Bx4{ IMPL_SINT4BX4(maskGreater) },
#	endif
		31);

	return abcd_truncated - oneIfGreater;
}

// Rounds the given fixed-point number with the given number of fraction bits to the nearest integer.
SInt8B roundedFixedPoint(
	SInt8B number,
	UInt1B numberOfFractionBits
) {
	// Two problems here:
	//  1) C++ does not define right-shift of signed numbers to be logical (all bits shifted right; filled with zeroes) or
	//     arithmetic (equals division by 2^x). Its implementation-defined.
	//  2) C++ does not define whether the division of a negative number rounds up or down; it only guarantees (a/b*b+a%b == a).
	//     Its also implementation-defined.
	// Round-down arithmetic right-shift is generated by Visual C++, GCC, and Clang.
	static_assert(-3 >> 1 == -2, "requires round-down arithmetic shift");
	return (number + (SInt8B(1) << numberOfFractionBits) / 2) >> numberOfFractionBits;
}
SInt4B roundedFixedPoint(
	SInt4B number,
	UInt1B numberOfFractionBits
) {
	// Two problems here:
	//  1) C++ does not define right-shift of signed numbers to be logical (all bits shifted right; filled with zeroes) or
	//     arithmetic (equals division by 2^x). Its implementation-defined.
	//  2) C++ does not define whether the division of a negative number rounds up or down; it only guarantees (a/b*b+a%b == a).
	//     Its also implementation-defined.
	// Round-down arithmetic right-shift is generated by Visual C++, GCC, and Clang.
	static_assert(-3 >> 1 == -2, "requires round-down arithmetic shift");
	return (number + (SInt4B(1) << numberOfFractionBits) / 2) >> numberOfFractionBits;
}

// Converts to integer by truncating all digits after the decimal point.
//   must be in [-2 147 483 648, +2 147 483 520] range
//     deviation from signed 4-B integer maximum is due to floating-point accuracy
//   other interpretations:
//     floored() for positive numbers; ceiled() for negative numbers
//     rounding towards zero
SInt4B truncated(float const value) {
	MUST(-2'147'483'648.0f <= value && value <= 2'147'483'520.0f);

	//  SSEs CVTTSS2SI instruction is the perfect solution
	//  all compilers emit CVTTSS2SI for float-to-int casts when compiling for SSE
	//    tested with Clang & Visual C++ 2017
	//    Clang does not even support __builtin_ia32_cvttss2si()
	//    _mm_cvtt_ss2si() intrinsic on Visual C++ probably causes inferior code generation
	return SInt4B(value);
}

// Converts to integer by truncating all digits after the decimal point.
//   all lanes must be in [-2 147 483 648, +2 147 483 520] range
//     deviation from signed 4-B integer maximum is due to floating-point accuracy
//   other interpretations:
//     floored() for positive numbers; ceiled() for negative numbers
//     rounding towards zero
SInt4Bx4 SIMD_CALL truncated(floatx4 const abcd) {
	MUST(areAllLanesWithin(-2'147'483'648.0f, abcd, 2'147'483'520.0f));

	//  SSE2s CVTTPS2PI instruction is the perfect solution
	//  Visual C++: only available via _mm_cvttps_epi32() intrinsic
	//  Clang/GCC: probably emitted on vector float-to-int cast, but use __builtin_ia32_cvttps2dq() just to be sure
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cvttps_epi32(abcd.floats) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_cvttps2dq(abcd.floats) };
#	endif
}

UInt1B flippedEndianness(UInt1B value) {
	return value;
}
UInt2B flippedEndianness(UInt2B value) {
#	if COMPILED_BY_VISUAL_CPP
		return _byteswap_ushort(value);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		// Clang has no __builtin_bswap16() for consistency with GCC, but this expression generates a single swap instruction:
		return (value >> 8u) | (value << 8u);
#	endif
}
UInt4B flippedEndianness(UInt4B value) {
#	if COMPILED_BY_VISUAL_CPP
		return _byteswap_ulong(value);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_bswap32(value);
#	endif
}
UInt8B flippedEndianness(UInt8B value) {
#	if COMPILED_BY_VISUAL_CPP
		return _byteswap_uint64(value);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return __builtin_bswap64(value);
#	endif
}

UInt1B bigEndian(UInt1B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return flippedEndianness(value);
#	elif COMPILED_FOR_BIG_ENDIAN
		return value;
#	endif
}
UInt2B bigEndian(UInt2B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return flippedEndianness(value);
#	elif COMPILED_FOR_BIG_ENDIAN
		return value;
#	endif
}
UInt4B bigEndian(UInt4B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return flippedEndianness(value);
#	elif COMPILED_FOR_BIG_ENDIAN
		return value;
#	endif
}
UInt8B bigEndian(UInt8B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return flippedEndianness(value);
#	elif COMPILED_FOR_BIG_ENDIAN
		return value;
#	endif
}
SInt1B bigEndian(SInt1B value) {
	return bigEndian(UInt1B(value));
}
SInt2B bigEndian(SInt2B value) {
	return bigEndian(UInt2B(value));
}
SInt4B bigEndian(SInt4B value) {
	return bigEndian(UInt4B(value));
}
SInt8B bigEndian(SInt8B value) {
	return bigEndian(UInt8B(value));
}

UInt1B littleEndian(UInt1B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return value;
#	elif COMPILED_FOR_BIG_ENDIAN
		return flippedEndianness(value);
#	endif
}
UInt2B littleEndian(UInt2B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return value;
#	elif COMPILED_FOR_BIG_ENDIAN
		return flippedEndianness(value);
#	endif
}
UInt4B littleEndian(UInt4B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return value;
#	elif COMPILED_FOR_BIG_ENDIAN
		return flippedEndianness(value);
#	endif
}
UInt8B littleEndian(UInt8B value) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return value;
#	elif COMPILED_FOR_BIG_ENDIAN
		return flippedEndianness(value);
#	endif
}
SInt1B littleEndian(SInt1B value) {
	return littleEndian(UInt1B(value));
}
SInt2B littleEndian(SInt2B value) {
	return littleEndian(UInt2B(value));
}
SInt4B littleEndian(SInt4B value) {
	return littleEndian(UInt4B(value));
}
SInt8B littleEndian(SInt8B value) {
	return littleEndian(UInt8B(value));
}

// Shifts an integer n bits to the right, replicating the sign.
//   use for clarity (C/C++ do not define whether the >> operator pads in zeroes or the sign)
//   shift count must be below number of bits in the operand (C/C++ convention)
//   equals division by a power of two, rounding towards negative infinity
SIntLeast1B shiftRightArithmetic(SInt1B const number, UIntLeast1B const bits) {
	MUST(bits <= 7); // otherwise undefined
#	if COMPILED_BY_CLANG || COMPILED_BY_GCC || COMPILED_BY_VISUAL_CPP // these guarantee arithmetic shifts with signed integers
		return number >> bits;
#	else
#		error TODO
#	endif
}
SIntLeast2B shiftRightArithmetic(SInt2B const number, UIntLeast1B const bits) {
	MUST(bits <= 15); // otherwise undefined
#	if COMPILED_BY_CLANG || COMPILED_BY_GCC || COMPILED_BY_VISUAL_CPP // these guarantee arithmetic shifts with signed integers
		return number >> bits;
#	else
#		error TODO
#	endif
}
SIntLeast4B shiftRightArithmetic(SInt4B const number, UIntLeast1B const bits) {
	MUST(bits <= 31); // otherwise undefined
#	if COMPILED_BY_CLANG || COMPILED_BY_GCC || COMPILED_BY_VISUAL_CPP // these guarantee arithmetic shifts with signed integers
		return number >> bits;
#	else
#		error TODO
#	endif
}
SIntLeast8B shiftRightArithmetic(SInt8B const number, UIntLeast1B const bits) {
	MUST(bits <= 63); // otherwise undefined
#	if COMPILED_BY_CLANG || COMPILED_BY_GCC || COMPILED_BY_VISUAL_CPP // these guarantee arithmetic shifts with signed integers
		return number >> bits;
#	else
#		error TODO
#	endif
}
SInt4Bx4 SIMD_CALL shiftRightArithmetic(SInt4Bx4 const xyzw, UIntLeast1B const bits) {
	MUST(bits <= 31); // otherwise undefined
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_srai_epi32(xyzw.ints, int(bits)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_psradi128(xyzw, int(bits)) };
#	endif
}

UInt4B rightRotated(UInt4B const number, UIntLeast1B const bits) {
	MUST(bits < 32);
#	if COMPILED_BY_VISUAL_CPP
		return _rotr(number, bits);
#	else
		if(0 == bits) { // fucking undefined x << 32
			return number;
		} else {
			return (number >> bits) | (number << (32 - bits));
		}
#	endif
}

// Returns the two given ASCII characters as an integer as if loaded from memory.
// Handy for magic numbers in file formats (e.g. BM in .bmp), where two comparisons of two characters each can be replaced
//  with one comparison of two-byte numbers.
UInt2B asInt(ASCIICharacter const (& twoChars)[3]) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return UInt1B(twoChars[0])
		    | (UInt1B(twoChars[1]) << 8);
#	elif COMPILED_FOR_BIG_ENDIAN
		return (UInt1B(twoChars[0]) << 8)
		      | UInt1B(twoChars[1]);
#	endif
}
// Returns the four given ASCII characters as an integer as if loaded from memory (FourCC).
// Handy for magic numbers in file formats (e.g. RIFF in .avi and .wav), where four comparisons of two characters each can be
//  replaced with one comparison of four-byte numbers.
UInt4B asInt(ASCIICharacter const (& fourChars)[5]) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return UInt1B(fourChars[0])
		    | (UInt1B(fourChars[1]) <<  8)
		    | (UInt1B(fourChars[2]) << 16)
		    | (UInt1B(fourChars[3]) << 24);
#	elif COMPILED_FOR_BIG_ENDIAN
		return (UInt1B(fourChars[0]) << 24)
		     | (UInt1B(fourChars[1]) << 16)
		     | (UInt1B(fourChars[2]) <<  8)
		     |  UInt1B(fourChars[3]);
#	endif
}
// Returns the eight given ASCII characters as an integer as if loaded from memory.
// Handy for magic numbers in file formats, where eight comparisons of two characters each can be replaced with one comparison
//  of eight-byte numbers.
UInt8B asInt(ASCIICharacter const (& eightChars)[9]) {
#	if COMPILED_FOR_LITTLE_ENDIAN
		return        UInt1B(eightChars[0])
		    | (       UInt1B(eightChars[1])  <<  8)
		    | (       UInt1B(eightChars[2])  << 16)
		    | (       UInt1B(eightChars[3])  << 24)
		    | (UInt8B(UInt1B(eightChars[4])) << 32)
		    | (UInt8B(UInt1B(eightChars[5])) << 40)
		    | (UInt8B(UInt1B(eightChars[6])) << 48)
		    | (UInt8B(UInt1B(eightChars[7])) << 56);
#	elif COMPILED_FOR_BIG_ENDIAN
		return        UInt1B(eightChars[7])
		    | (       UInt1B(eightChars[6])  <<  8)
		    | (       UInt1B(eightChars[5])  << 16)
		    | (       UInt1B(eightChars[4])  << 24)
		    | (UInt8B(UInt1B(eightChars[3])) << 32)
		    | (UInt8B(UInt1B(eightChars[2])) << 40)
		    | (UInt8B(UInt1B(eightChars[1])) << 48)
		    | (UInt8B(UInt1B(eightChars[0])) << 56);
#	endif
}

// Returns the floored binary logarithm of the given number (equals the index of the most significant bit set, with 0 for LSB).
//   undefined for zero
UIntLeast1B binaryLogarithmOf(USize value) {
	MUST(0 < value);
#	if COMPILED_BY_VISUAL_CPP
		unsigned long result;
#		if COMPILED_FOR_X86_32
			_BitScanReverse(&result, value);
#		elif COMPILED_FOR_X86_64
			_BitScanReverse64(&result, value);
#		endif
		return result;
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
#		if COMPILED_FOR_X86_32
			return 31 - __builtin_clz(value);
#		elif COMPILED_FOR_X86_64
			return 63 - __builtin_clzll(value);
#		endif
#	endif
}

// Determines whether the given integer is evenly divisable by two.
//   zero is even
bool isEven(SInt4B x) {
	return 0 == (x & 1);
}

// Determines whether the given number is negative.
//   negative zero returns yes
//   NaN is undefined
bool isNegative(float value) {
	// 1. isolate the sign bit
	// 2. reinterpret as integer (after 1. because the integer SSE opcodes are longer)
	auto signBitFloat = x___From(value) & floatx4SignMask_XYZW();
	auto signBitInt   = SInt4Bx4{
#		if COMPILED_BY_VISUAL_CPP
			_mm_castps_si128(signBitFloat.floats)
#		else
			IMPL_SINT4BX4(signBitFloat.floats)
#		endif
	};
	// 3. move X component to general purpose register
	// 4. non-zero value means the sign bit is set
	return 0 != xOf(signBitInt);
}



// Reports the given event to the given supervisor (if existent).
// Designed for inlining & quick rejection by the optimizer if the supervisor is nullptr.
SSize report(
	Supervisor const * const supervisorOrNull,
	UIntLeast4B const        event
) {
	if(nullptr == supervisorOrNull) {
		return 1;
	} else {
		return report(*supervisorOrNull, event);
	}
}
SSize report(
	Supervisor const * const supervisorOrNull,
	UIntLeast4B const        event,
	void const * const       more
) {
	if(nullptr == supervisorOrNull) {
		return 1;
	} else {
		return report(*supervisorOrNull, event, more);
	}
}
SSize report(
	Supervisor const * const supervisorOrNull,
	UIntLeast4B const        event,
	UCount const             more
) {
	if(nullptr == supervisorOrNull) {
		return 1;
	} else {
		return report(*supervisorOrNull, event, reinterpret_cast<void *>(more));
	}
}

SSize OUTLINE_CODE report(
	Supervisor const & supervisor,
	UIntLeast4B const  event
) {
	return report(supervisor, event, nullptr);
}
SSize OUTLINE_CODE report(
	Supervisor const & supervisor,
	UIntLeast4B const  event,
	void const * const more
) {
	if(0x80000000 <= event) {
		UTF16Unit callStack[16 * 48];
		OS::Win32::captureCallStack(callStack);
		return supervisor.onEvent(supervisor.context, event, more, callStack);
	} else {
		return supervisor.onEvent(supervisor.context, event, more, nullptr);
	}
}

// Reports an Info::progress event to the given supervisor (if existent).
//   returns no on cancellation
bool onProgress(
	Supervisor const * const supervisorOrNull,
	UIntLeast4B const        perMille
) {
	MUST(perMille <= 1000);

	if(nullptr == supervisorOrNull) {
		return 1;
	} else {
		return 0 != supervisorOrNull->onEvent(supervisorOrNull->context, Info::progress, (void const *)USize(perMille), nullptr);
	}
}



// Loads four elements from the given address.
//  no alignment required
//  memory order (lowest address becomes first element)
UInt1Bx4 SIMD_CALL loadx4(UInt1B const memory[4]) {
#	if COMPILED_BY_VISUAL_CPP
		// Load one 32-bit integer with all four 8-bit values.
		return { _mm_cvtsi32_si128(*reinterpret_cast<SInt4B const *>(memory)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { { memory[0], memory[1], memory[2], memory[3] } };
#	endif
}

// Creates a vector of four elements with the given value.
UInt1Bx4 SIMD_CALL loadx4(UInt1B const v) {
#	if COMPILED_BY_VISUAL_CPP
		// Replicate in the general purpose registers:
		auto const v000 = _mm_cvtsi32_si128(v);
		auto const vv00 = _mm_unpacklo_epi8(v000, v000);
		auto const vvvv = _mm_unpacklo_epi16(vv00, vv00);
		return { vvvv };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { { v, v, v, v } };
#	endif
}

// Writes all four elements to the given address.
//  no alignment required
//  memory order (lowest address gets first element)
void SIMD_CALL store(UInt1B memory[4], UInt1Bx4 v) {
#	if COMPILED_BY_VISUAL_CPP
		// Store one 32-bit integer with all four 8-bit values.
		*reinterpret_cast<SInt4B *>(memory) = _mm_cvtsi128_si32(v.uints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		memory[0] = v.uints[0];
		memory[1] = v.uints[1];
		memory[2] = v.uints[2];
		memory[3] = v.uints[3];
#	endif
}

// Expands all elements to 4-B signed integers.
SInt4Bx4 SIMD_CALL asSInt4B(UInt1Bx4 v) {
#	if COMPILED_BY_VISUAL_CPP
		// Interleave each lane with 24 zero bits.
		return { _mm_unpacklo_epi16(_mm_unpacklo_epi8(v.uints, _mm_setzero_si128()), _mm_setzero_si128()) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints[0], v.uints[1], v.uints[2], v.uints[3] };
#	endif
}

// Expands all elements to 2-B unsigned integers.
UInt2Bx4 SIMD_CALL asUInt2B(UInt1Bx4 v) {
#	if COMPILED_BY_VISUAL_CPP
		// Interleave each lane with eight zero bits.
		return { _mm_unpacklo_epi8(v.uints, _mm_setzero_si128()) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints[0], v.uints[1], v.uints[2], v.uints[3] };
#	endif
}




// Creates a vector of four elements with the given value.
UInt2Bx4 SIMD_CALL loadx4(UInt2B v) {
#	if COMPILED_BY_VISUAL_CPP
		// Replicate in the general purpose registers:
		auto const v000 = _mm_cvtsi32_si128(v);
		auto const vv00 = _mm_unpacklo_epi16(v000, v000);
		auto const vvvv = _mm_unpacklo_epi32(vv00, vv00);
		return { vvvv };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v, v, v, v };
#	endif
}

// Broadcasts lane [0]s value.
UInt2Bx4 SIMD_CALL aaaa_of(UInt2Bx4 const v) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shufflelo_epi16(v.uints, 0b00'00'00'00) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints[0], v.uints[0], v.uints[0], v.uints[0] };
#	endif
}

// Broadcasts lane [1]s value.
UInt2Bx4 SIMD_CALL bbbb_of(UInt2Bx4 const v) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shufflelo_epi16(v.uints, 0b01'01'01'01) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints[1], v.uints[1], v.uints[1], v.uints[1] };
#	endif
}

// Broadcasts lane [2]s value.
UInt2Bx4 SIMD_CALL cccc_of(UInt2Bx4 const v) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shufflelo_epi16(v.uints, 0b10'10'10'10) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints[2], v.uints[2], v.uints[2], v.uints[2] };
#	endif
}

// Broadcasts lane [3]s value.
UInt2Bx4 SIMD_CALL dddd_of(UInt2Bx4 const v) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_shufflelo_epi16(v.uints, 0b11'11'11'11) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints[3], v.uints[3], v.uints[3], v.uints[3] };
#	endif
}

UInt2Bx4 SIMD_CALL operator *(UInt2Bx4 const l, UInt2Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_mullo_epi16(l.uints, r.uints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return {
			l.uints[0] * r.uints[0],
			l.uints[1] * r.uints[1],
			l.uints[2] * r.uints[2],
			l.uints[3] * r.uints[3]
			// Do not multiply padding lanes, as this causes a needless PMULHW!
		};
#	endif
}

UInt2Bx4 SIMD_CALL operator +(UInt2Bx4 const l, UInt2Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_add_epi16(l.uints, r.uints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { l.uints + r.uints };
#	endif
}

UInt2Bx4 SIMD_CALL operator -(UInt2Bx4 const l, UInt2Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_sub_epi16(l.uints, r.uints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { l.uints - r.uints };
#	endif
}


// Shifts each lanes value to the right.
//   shifts in zeroes
//   implementation-defined if shift exceeds lane bit length (much like standard C++ shifts)
UInt4Bx4 SIMD_CALL shiftRightLogical(UInt4Bx4 const l, UIntLeast1B const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_srli_epi32(l.uints, r) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
	return { __builtin_ia32_psrldi128(l.uints, r) };
#	endif
}

UInt4Bx4 SIMD_CALL operator +(UInt4Bx4 const l, UInt4Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_add_epi32(l.uints, r.uints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return {
			l.uints[0] + r.uints[0],
			l.uints[1] + r.uints[1],
			l.uints[2] + r.uints[2],
			l.uints[3] + r.uints[3]
		};
#	endif
}

// Merges a and b according to the given bitmask.
//   for each lane, picks a if the according mask bit is zero, and b otherwise
UInt4Bx4 SIMD_CALL selectedByBitmask(UInt4Bx4 const a, UInt4Bx4 const b, UInt4Bx4 const mask) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_or_si128(_mm_andnot_si128(mask.uints, a.uints), _mm_and_si128(mask.uints, b.uints)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { (a.uints & ~mask.uints) | (b.uints & mask.uints) };
#	endif
}

// Converts all elements to 1-B unsigned integers.
//   over- and underflows are undefined
UInt1Bx4 SIMD_CALL asUInt1B(UInt4Bx4 const v) {
#	if COMPILED_BY_VISUAL_CPP
		MUST(v.uints.i32[0] <= 255 && v.uints.i32[1] <= 255 && v.uints.i32[2] <= 255 && v.uints.i32[3] <= 255);
		auto const as2B = _mm_packs_epi32(v.uints, v.uints); // signed saturation is arbitrary
		return { _mm_packus_epi16(as2B, as2B) }; // unsigned saturation is arbitrary
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		MUST(v.uints[0] <= 255 && v.uints[1] <= 255 && v.uints[2] <= 255 && v.uints[3] <= 255);
		auto const as2B = __builtin_ia32_packssdw128(v.uints, v.uints); // signed saturation is arbitrary
		return { __builtin_ia32_packuswb128(as2B, as2B) }; // unsigned saturation is arbitrary
#	endif
}



// Loads four elements from the given address.
//  no alignment required
//  memory order (lowest address becomes first element)
UNorm1Bx4 SIMD_CALL loadUNormx4(UInt1B const memory[4]) {
#	if COMPILED_BY_VISUAL_CPP
		// Load one 32-bit integer with all four 8-bit values.
		return { _mm_cvtsi32_si128(*reinterpret_cast<SInt4B const *>(memory)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { memory[0], memory[1], memory[2], memory[3], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
#	endif
}

// Creates a vector of four lanes with the given value.
UNorm1Bx4 SIMD_CALL loadUNorm1Bx4(UInt1B const v) {
#	if COMPILED_BY_VISUAL_CPP
		// Replicate in the general purpose registers:
		auto const v000 = _mm_cvtsi32_si128(v);
		auto const vv00 = _mm_unpacklo_epi8(v000, v000);
		auto const vvvv = _mm_unpacklo_epi16(vv00, vv00);
		return { vvvv };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v, v, v, v };
#	endif
}

// Creates a vector of four lanes with the given values.
UNorm1Bx4 SIMD_CALL loadUNorm1Bx4(UInt1B const a, UInt1B const b, UInt1B const c, UInt1B const d) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cvtsi32_si128(a << 0 | b << 8 | c << 16 | d << 24) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v, v, v, v };
#	endif
}

// Converts the given floating-point numbers in [0, 255] range to unsigned normalized numbers.
//   round-to-nearest
//   over- and underruns are saturated
UNorm1Bx4 SIMD_CALL asUNorm1B_0_255(floatx4 const xyzw_float) {
	auto const xyzw_int32 = rounded(xyzw_float);
#	if COMPILED_BY_VISUAL_CPP
		auto const xyzw_int16 = _mm_packs_epi32(xyzw_int32.ints, xyzw_int32.ints); // TODO: Unsigned saturation requires SSE 4.1!
		auto const xyzw_int8  = _mm_packus_epi16(xyzw_int16, xyzw_int16); // Unsigned saturation!
		return { xyzw_int8 };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		auto xyzw_int16 = __builtin_ia32_packsswb128(xyzw_int32.ints, xyzw_int32.ints); // TODO: Unsigned saturation requires SSE 4.1!
		auto xyzw_int8  = __builtin_ia32_packuswb128(xyzw_int16, xyzw_int16); // Unsigned saturation!
		return { { xyzw_int8[0], xyzw_int8[1], xyzw_int8[2], xyzw_int8[3] } };
#	endif
}

// Converts the given floating-point numbers in [0, 1] range to unsigned normalized numbers.
//   round-to-nearest
//   over- and underruns are saturated
UNorm1Bx4 SIMD_CALL asUNorm1B(floatx4 const abcd) {
	return asUNorm1B_0_255(loadx4(255.0f) * abcd);
}

UNorm1Bx4 SIMD_CALL operator +(UNorm1Bx4 const l, UNorm1Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_adds_epu8(l.unorms, r.unorms) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_paddusb128(l.unorms, r.unorms) };
#	endif
}

UNorm1Bx4 SIMD_CALL operator -(UNorm1Bx4 const l, UNorm1Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_subs_epu8(l.unorms, r.unorms) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { __builtin_ia32_psubusb128(l.unorms, r.unorms) };
#	endif
}

UNorm1Bx4 SIMD_CALL operator *(UNorm1Bx4 const l, UNorm1Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP

		// There is no 8-bit multiplication in SSE2, so interleave lanes with eight zero bits.
		auto const l16  = _mm_unpacklo_epi8(l.unorms, _mm_setzero_si128());
		auto const r16  = _mm_unpacklo_epi8(r.unorms, _mm_setzero_si128());
		// Multiply & renormalize.
		auto const lr16 = dividedBy255_UInt2Bx8(_mm_mullo_epi16(l16, r16));
		// Saturate and pack to 8-bit integers.
		return { _mm_packus_epi16(lr16, lr16) };

#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC

		// There is no 8-bit multiplication in SSE2, so use 16-bit numbers.
		IMPL_UINT2BX4 const l16  = { l.unorms[0], l.unorms[1], l.unorms[2], l.unorms[3] };
		IMPL_UINT2BX4 const r16  = { r.unorms[0], r.unorms[1], r.unorms[2], r.unorms[3] };
		IMPL_UINT2BX4 const _255 = { 255, 255, 255, 255 };
		// Multiply & renormalize.
		auto const lr16 = l16 * r16 / _255;
		// Saturate and pack to 8-bit integers.
		return { __builtin_ia32_packuswb128(lr16, lr16) };

#	endif
}

UNorm1Bx4 SIMD_CALL operator |(UNorm1Bx4 const l, UNorm1Bx4 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_or_si128(l.unorms, r.unorms) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { l.unorms | r.unorms };
#	endif
}

// For each lane, computes lx  rx + ly  ry.
//   useful for image processing:
//     alpha blending: foreground  alpha + background  (1 - alpha)
//     lighting: ambient  light + diffuse  light
UNorm1Bx4 SIMD_CALL dotProductOf(
	UNorm1Bx4 const lx,
	UNorm1Bx4 const rx,
	UNorm1Bx4 const ly,
	UNorm1Bx4 const ry
) {
#	if COMPILED_BY_VISUAL_CPP

		// SSE2s PMADDWD adds even lanes to odd ones. It expects 16-bit integers, so interleave lanes with eight zero bits.
		auto const lxy = _mm_unpacklo_epi8(_mm_unpacklo_epi8(lx.unorms, ly.unorms), _mm_setzero_si128());
		auto const rxy = _mm_unpacklo_epi8(_mm_unpacklo_epi8(rx.unorms, ry.unorms), _mm_setzero_si128());

		// The 32-bit result must be converted to 16 bits, but SSE2 only supports signed saturation  so divide by 255 right away.
		// According to StackOverflow, How to divide 16-bit integer by 255 with using SSE?:
		//
		//   There is an integer approximation of division by 255:
		//    (value + 1 + (value >> 8)) >> 8
		//
		// This has an overflow bug for huge numbers, but our case is unaffected because each lane is below 2^17.
		auto       result32 = _mm_madd_epi16(lxy, rxy);
		auto const one      = _mm_srli_epi32(xmmAllBitsOne(), 31);
		           result32 = _mm_srli_epi32(_mm_add_epi32(_mm_add_epi32(result32, one), _mm_srli_epi32(result32, 8)), 8);
		auto const result16 = _mm_packs_epi32(result32, result32);
		auto const result8  = _mm_packus_epi16(result16, result16);
		return { result8 };

#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { // TODO: __builtin_ia32_pmaddwd128?
			UInt4B(lx.unorms[0]) * UInt4B(ly.unorms[0]) + UInt4B(rx.unorms[0]) * UInt4B(ry.unorms[0]),
			UInt4B(lx.unorms[1]) * UInt4B(ly.unorms[1]) + UInt4B(rx.unorms[1]) * UInt4B(ry.unorms[1]),
			UInt4B(lx.unorms[2]) * UInt4B(ly.unorms[2]) + UInt4B(rx.unorms[2]) * UInt4B(ry.unorms[2]),
			UInt4B(lx.unorms[3]) * UInt4B(ly.unorms[3]) + UInt4B(rx.unorms[3]) * UInt4B(ry.unorms[3])
		};
#	endif
}

// Broadcasts lane [3]s value.
UNorm1Bx4 SIMD_CALL dddd_of(UNorm1Bx4 const v) {
#	if COMPILED_BY_VISUAL_CPP
		// There is no 8-bit shuffling in SSE2 
		//   shift lane [3] to the least significant byte
		//   interleave twice with itself
		auto const d000 = _mm_srli_epi32(v.unorms, 24);
		auto const dd00 = _mm_unpacklo_epi8(d000, d000);
		auto const dddd = _mm_unpacklo_epi16(dd00, dd00);
		return { dddd };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.unorms[3], v.unorms[3], v.unorms[3], v.unorms[3] };
#	endif
}

// Writes all four elements to the given address.
//  no alignment required
//  memory order (lowest address gets first element)
void SIMD_CALL store(UInt1B memory[4], UNorm1Bx4 const v) {
#	if COMPILED_BY_VISUAL_CPP
		// Store one 32-bit integer with all four 8-bit values.
		*reinterpret_cast<SInt4B *>(memory) = _mm_cvtsi128_si32(v.unorms);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		memory[0] = v.unorms[0];
		memory[1] = v.unorms[1];
		memory[2] = v.unorms[2];
		memory[3] = v.unorms[3];
#	endif
}


// Merges a and b according to the given bitmask.
//   for each lane, picks a if the according mask bit is zero, and b otherwise
local IMPL_UINT1BX16 SIMD_CALL selectedByBitmask(
	IMPL_UINT1BX16 const a,
	IMPL_UINT1BX16 const b,
	IMPL_UINT1BX16 const mask
) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_or_si128(_mm_andnot_si128(mask, a), _mm_and_si128(mask, b)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return (a & ~mask) | (b & mask);
#	endif
}

// Converts the given unsigned 1-B integers to hexadecimal ASCII digits & letters.
local IMPL_UINT1BX16 SIMD_CALL hexadecimalDigitsFrom(IMPL_UINT1BX8 const numbers) {

	// Unpack all high nibbles to even bytes, and all low nibbles to odd bytes.
#	if COMPILED_BY_VISUAL_CPP
		auto const  oddNibbles = _mm_srli_epi16(_mm_unpacklo_epi8(numbers, _mm_setzero_si128()), 4);
		auto const evenNibbles = _mm_and_si128(_mm_unpacklo_epi8(_mm_setzero_si128(), numbers), _mm_set1_epi8(0xF));
		auto const  allNibbles = _mm_or_si128(oddNibbles, evenNibbles);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		IMPL_UINT1BX16 const oddNibbles  = {
			numbers[0] >> 4, 0,
			numbers[1] >> 4, 0,
			numbers[2] >> 4, 0,
			numbers[3] >> 4, 0,
			numbers[4] >> 4, 0,
			numbers[5] >> 4, 0,
			numbers[6] >> 4, 0,
			numbers[7] >> 4, 0
		};
		IMPL_UINT1BX16 const evenNibbles = {
			0, numbers[0] & 0xF,
			0, numbers[1] & 0xF,
			0, numbers[2] & 0xF,
			0, numbers[3] & 0xF,
			0, numbers[4] & 0xF,
			0, numbers[5] & 0xF,
			0, numbers[6] & 0xF,
			0, numbers[7] & 0xF
		};
		auto const allNibbles = oddNibbles | evenNibbles;
#	endif

	// Compute decimal digits (09) as well as hexadecimal letters (AF). Select
	//   the character if the byte is 10 (A) or more
	//   the digit if the byte is 09
#	if COMPILED_BY_VISUAL_CPP
		auto const digits     = _mm_add_epi8(allNibbles, _mm_set1_epi8('0'));
		auto const chars      = _mm_add_epi8(allNibbles, _mm_set1_epi8('A' - 10));
		auto const is10orMore = _mm_cmplt_epi8(_mm_set1_epi8(9), allNibbles); // operands flipped
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		auto const digits     = allNibbles + IMPL_UINT1BX16{ '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0' };
		auto const chars      = allNibbles + IMPL_UINT1BX16{ 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10, 'A' - 10 };
		auto const is10orMore = IMPL_UINT1BX16{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 } < allNibbles;
#	endif
	return selectedByBitmask(digits, chars, is10orMore);
}

// Converts the given number to a zero-padded hexadecimal string. Returns a register with eight ASCII characters in memory
//  order.
UInt1Bx8 SIMD_CALL toHexadecimalZeroPaddedString_reg(UInt4B const number) {

	// Load the number for processing all eight nibbles in parallel.
	//   Consider endianness: The most significant byte must go to the lowest address!
	auto const bytes =
#	if COMPILED_BY_VISUAL_CPP
		_mm_cvtsi32_si128(bigEndian(number));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		IMPL_UINT1BX8(IMPL_UINT4BX4{ bigEndian(number), 0, 0, 0 });
#	endif

	return { hexadecimalDigitsFrom(bytes) };
}

// Expands all elements to 2-B unsigned integers.
UInt2Bx8 SIMD_CALL asUInt2B(UInt1Bx8 const v) {
#	if COMPILED_BY_VISUAL_CPP
		// Zero every other byte via interleaving.
		return { _mm_unpacklo_epi8(v.uints, _mm_setzero_si128()) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return UInt2Bx8{
			v.uints[ 0], v.uints[ 1], v.uints[ 2], v.uints[ 3], v.uints[ 4], v.uints[ 5], v.uints[ 6], v.uints[ 7]
		};
#	endif
}





// Loads 16 elements from the given address.
//  no alignment required
//  memory order (lowest address becomes first element)
SInt1Bx16 SIMD_CALL loadx16(ASCIICharacter const memory[16]) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_loadu_si128(reinterpret_cast<__m128i const *>(memory)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return {
			memory[ 0], memory[ 1], memory[ 2], memory[ 3], memory[ 4], memory[ 5], memory[ 6], memory[ 7],
			memory[ 8], memory[ 9], memory[10], memory[11], memory[12], memory[13], memory[14], memory[15]
		};
#	endif
}

// Creates a vector of 16 elements with the given value.
SInt1Bx16 SIMD_CALL loadx16(ASCIICharacter const value) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set1_epi8(value) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return {
			value, value, value, value, value, value, value, value,
			value, value, value, value, value, value, value, value
		};
#	endif
}

SInt1Bx16 SIMD_CALL operator &(SInt1Bx16 const a, SInt1Bx16 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_and_si128(a.ints, b.ints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.ints & b.ints };
#	endif
}
SInt1Bx16 SIMD_CALL operator |(SInt1Bx16 const a, SInt1Bx16 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_or_si128(a.ints, b.ints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.ints | b.ints };
#	endif
}

// Returns a bit mask per lane:
//   1 where left < right
//   0 where left >= right
//   0 where either side is NaN
SInt1Bx16 SIMD_CALL mask_isLower(SInt1Bx16 const l, SInt1Bx16 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmplt_epi8(l.ints, r.ints) };
#	elif COMPILED_BY_CLANG
		return { l.ints < r.ints };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpltps(l, r) };
#	endif
}

// Returns a bit mask per lane:
//   1 where left > right
//   0 where left <= right
//   0 where either side is NaN
SInt1Bx16 SIMD_CALL mask_isGreater(SInt1Bx16 const l, SInt1Bx16 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmplt_epi8(r.ints, l.ints) }; // operands flipped
#	elif COMPILED_BY_CLANG
		return { l.ints > r.ints };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpgtps(l, r) };
#	endif
}

// Returns a bit mask per lane:
//   1 where left == right
//   0 where left != right
//   0 where either side is NaN
SInt1Bx16 SIMD_CALL mask_isEqual(SInt1Bx16 const l, SInt1Bx16 const r) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_cmpeq_epi8(l.ints, r.ints) };
#	elif COMPILED_BY_CLANG
		return { l.ints == r.ints };
#	elif COMPILED_BY_GCC
		return { __builtin_ia32_cmpeqps(l, r) };
#	endif
}

//  memory order (0 is first lane from memory)
//  masked means all bits set
//  returns 16 if no lane is found
UIntLeast1B SIMD_CALL indexOfFirstMaskedLaneIn(SInt1Bx16 const v) {
	auto const bitMask = 
#		if COMPILED_BY_VISUAL_CPP
			_mm_movemask_epi8(v.ints);
#		elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			__builtin_ia32_pmovmskb128(v.ints);
#		endif
	unsigned long result;
	if(_BitScanForward(&result, bitMask)) {
		return result;
	} else {
		return 16;
	}
}






// Loads 16 elements from the given address.
//   no alignment required
//   memory order (lowest address becomes first element)
UInt1Bx16 SIMD_CALL loadx16(UInt1B const memory[16]) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_loadu_si128(reinterpret_cast<__m128i const *>(memory)) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return {
			memory[ 0], memory[ 1], memory[ 2], memory[ 3], memory[ 4], memory[ 5], memory[ 6], memory[ 7],
			memory[ 8], memory[ 9], memory[10], memory[11], memory[12], memory[13], memory[14], memory[15]
		};
#	endif
}

// Creates a vector of 16 elements with the given value.
UInt1Bx16 SIMD_CALL loadx16(UInt1B const value) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_set1_epi8(value) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return {
			value, value, value, value, value, value, value, value,
			value, value, value, value, value, value, value, value
		};
#	endif
}

// Loads eight elements from the first address and appends eight elements from the second address.
//   no alignment required
//   memory order (lowest address becomes first element)
//   useful for matrix transposing
UInt1Bx16 SIMD_CALL loadx8x2(UInt1B const * const to0_7, UInt1B const * const to8_15) {
#	if COMPILED_BY_VISUAL_CPP
		auto const a = _mm_loadl_epi64(reinterpret_cast<SInt4B const *>(to0_7));
		auto const b = _mm_loadl_epi64(reinterpret_cast<SInt4B const *>(to8_15));
		return { _mm_unpacklo_epi64(a, b) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return {
			 to0_7[0],  to0_7[1],  to0_7[2],  to0_7[3],  to0_7[4],  to0_7[5],  to0_7[6],  to0_7[7],
			to8_15[0], to8_15[1], to8_15[2], to8_15[3], to8_15[4], to8_15[5], to8_15[6], to8_15[7]
		};
#	endif
}

// Converts the given number to a zero-padded hexadecimal string. Returns a register with 16 ASCII characters in memory order.
UInt1Bx16 SIMD_CALL toHexadecimalZeroPaddedString_reg(UInt8B const number) {
	// Load the number in order to process all 16 nibbles in parallel.
	//   Consider endianness: The most significant byte must go to the lowest address!
	auto const bytes =
#		if COMPILED_BY_VISUAL_CPP
			// There is no 64-bit SSE load on 32-bit x86!
#			if COMPILED_FOR_X86_64
				 _mm_cvtsi64x_si128(bigEndian(number));
#			elif COMPILED_FOR_X86_32
				_mm_unpacklo_epi32(
					_mm_cvtsi32_si128(bigEndian(reinterpret_cast<UInt4B const *>(&number)[1])),
					_mm_cvtsi32_si128(bigEndian(reinterpret_cast<UInt4B const *>(&number)[0]))
				);
#			else
#				error TODO
#			endif
#		elif COMPILED_BY_CLANG || COMPILED_BY_GCC
			IMPL_UINT1BX16(IMPL_UINT8BX2{ bigEndian(number), 0 });
#		endif

	return { hexadecimalDigitsFrom(bytes) };
}

// Expands all elements to 2-B unsigned integers.
UInt2Bx16 SIMD_CALL asUInt2B(UInt1Bx16 const v) {
#	if COMPILED_BY_VISUAL_CPP
		// Zero every other byte via interleaving.
		return {
			_mm_unpacklo_epi8(v.uints, _mm_setzero_si128()),
			_mm_unpackhi_epi8(v.uints, _mm_setzero_si128())
		};
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return UInt2Bx16{
			v.uints[ 0], v.uints[ 1], v.uints[ 2], v.uints[ 3], v.uints[ 4], v.uints[ 5], v.uints[ 6], v.uints[ 7],
			v.uints[ 8], v.uints[ 9], v.uints[10], v.uints[11], v.uints[12], v.uints[13], v.uints[14], v.uints[15]
		};
#	endif
}

// Writes all 16 elements to the given address.
//   no alignment required
//   memory order (lowest address gets first element)
void SIMD_CALL store(UInt1B memory[16], UInt1Bx16 const v) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storeu_si128(reinterpret_cast<__m128i *>(memory), v.uints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		for(auto i = 0; i < 16; ++i) {
			memory[i] = v.uints[i];
		}
#	endif
}

// Writes the first eight elements to the first address and the last eight to the other.
//   no alignment required
//   memory order (lowest address gets first element)
//   useful for matrix transposing
void SIMD_CALL store8x2(
	UInt1B * const  to0_7,
	UInt1B * const  to8_15,
	UInt1Bx16 const v
) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storel_epi64(reinterpret_cast<SInt4B *>(to0_7), v.uints);
		_mm_storel_epi64(reinterpret_cast<SInt4B *>(to8_15), SWIZZLED_INT4BX4(v.uints, 2, 3, 0, 1));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		for(int i = 0; i < 8; ++i) {
			to0_7[i]  = v.uints[i];
			to8_15[i] = v.uints[i + 8];
		}
#	endif
}

bool SIMD_CALL areAllLanesZero(UInt1Bx16 const v) {
#	if COMPILED_BY_VISUAL_CPP
		// 1. compare all lanes to zero, thereby setting non-zero lanes entirely to one
		// 2. extract each lanes most significant bit into a 16-bit integer
		// 3. if all bits are one, all lanes are zero
		return 0xFFFF == _mm_movemask_epi8(_mm_cmpeq_epi8(v.uints, _mm_setzero_si128()));
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		// 1. compare all lanes to zero, thereby setting non-zero lanes entirely to one
		// 2. extract each lanes most significant bit into a 16-bit integer
		// 3. if all bits are one, all lanes are zero
		return 0xFFFF == __builtin_ia32_pmovmskb128(v.uints == IMPL_UINT1BX16{ 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0 });
#	endif
}

UInt1Bx16 SIMD_CALL operator &(UInt1Bx16 const a, UInt1Bx16 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_and_si128(a.uints, b.uints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.uints & b.uints };
#	endif
}
UInt1Bx16 SIMD_CALL operator |(UInt1Bx16 const a, UInt1Bx16 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_or_si128(a.uints, b.uints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.uints | b.uints };
#	endif
}
UInt1Bx16 SIMD_CALL operator ^(UInt1Bx16 const a, UInt1Bx16 const b) {
#	if COMPILED_BY_VISUAL_CPP
		return { _mm_xor_si128(a.uints, b.uints) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { a.uints ^ b.uints };
#	endif
}
UInt1Bx16 SIMD_CALL operator <<(UInt1Bx16 const v, UIntLeast1B const bits) { // componentwise left shift
	MUST(bits <= 7); // undefined otherwise
#	if COMPILED_BY_VISUAL_CPP
		// There is no shift for 1-B integers. Emulate with AND and 32-bit shifts.
		auto const mask    = _mm_set1_epi8(0xFF << bits);
		auto const shifted = _mm_slli_epi32(v.uints, bits);
		return { _mm_and_si128(shifted, mask) };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints << bits };
#	endif
}

// Merges a and b according to the given bitmask.
//   for each lane, picks a if the according mask bit is zero, and b otherwise
UInt1Bx16 SIMD_CALL selectedByBitmask(UInt1Bx16 const a, UInt1Bx16 const b, UInt1Bx16 const mask) {
	return { selectedByBitmask(a.uints, b.uints, mask.uints) };
}

UInt1Bx16 & SIMD_CALL operator |=(UInt1Bx16 & a, UInt1Bx16 const b) {
	return a = a | b;
}




// Writes all eight elements to the given address.
//   no alignment required
//   memory order (lowest address gets first element)
void SIMD_CALL store(UInt2B memory[8], UInt2Bx8 const v) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storeu_si128(reinterpret_cast<__m128i *>(memory), v.uints);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		for(int i = 0; i < 16; ++i) {
			memory[i] = v.uints[i];
		}
#	endif
}




// Writes all 16 elements to the given address.
//   no alignment required
//   memory order (lowest address gets first element)
void SIMD_CALL store(UInt2B memory[16], UInt2Bx16 const v) {
#	if COMPILED_BY_VISUAL_CPP
		_mm_storeu_si128(reinterpret_cast<__m128i *>(memory    ), v.uints.a);
		_mm_storeu_si128(reinterpret_cast<__m128i *>(memory + 8), v.uints.b);
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		for(int i = 0; i < 16; ++i) {
			memory[i] = v.uints[i];
		}
#	endif
}

UInt2Bx8 SIMD_CALL lanes0To7Of(UInt2Bx16 const v) {
#	if COMPILED_BY_VISUAL_CPP
		return { v.uints.a };
#	elif COMPILED_BY_CLANG || COMPILED_BY_GCC
		return { v.uints[0], v.uints[1], v.uints[2], v.uints[3], v.uints[4], v.uints[5], v.uints[6], v.uints[7] };
#	endif
}


bool operator ==(UUID const & a, UUID const & b) {
	auto aAs8B = reinterpret_cast<UInt8B const *>(&a);
	auto bAs8B = reinterpret_cast<UInt8B const *>(&b);
	return aAs8B[0] == bAs8B[0] && aAs8B[1] == bAs8B[1];
}
bool operator !=(UUID const & a, UUID const & b) {
	return !(a == b);
}