// Formats numbers and strings.
struct ASCIIFormat {
	// Pointer to a function which actually writes the given ASCII string to a file/screen/printer/.
	void (*toWriter)(ASCIIFormat const &, ASCIICharacter const * begin, ASCIICharacter const * end);

	ASCIIFormat const & operator <<(ASCIICharacter const * toZeroTerminatedString) const; // out << "oh hai!";
	ASCIIFormat const & operator <<(Range<ASCIICharacter const> const &) const;
	ASCIIFormat const & operator <<(ASCIICharacter) const; // out << '!';

	ASCIIFormat const & operator <<(UTF16Unit const * toZeroTerminatedString) const;
	ASCIIFormat const & operator <<(Range<UTF16Unit const> const &) const;

	ASCIIFormat const & operator <<(UInt1B) const;
	ASCIIFormat const & operator <<(UInt2B) const;
	ASCIIFormat const & operator <<(UInt4B) const;
	ASCIIFormat const & operator <<(UInt8B) const;
	ASCIIFormat const & operator <<(SInt1B) const;
	ASCIIFormat const & operator <<(SInt2B) const;
	ASCIIFormat const & operator <<(SInt4B) const;
	ASCIIFormat const & operator <<(SInt8B) const;
	ASCIIFormat const & operator <<(double) const;
};


// Writes formatted ASCII to a file.
struct ASCIIToFile : ASCIIFormat {
	void * file;

	ASCIIToFile();

};

extern ASCIIToFile const out; // stdout